C--------------------------------------------------------------------- STRUCTURE OF 'MATRIX'
C
C

                            
C      1  wavelength (A)
C      2  EW   (mA)
C      3  loggf
C      4  EP   (eV)
C      5  element code (Kurucz format)
C      6  abundance (dex)
C      7  abundance error due to the EW error (dex)
C      8  EW error (mA)
C      9  EW error (%)
C     10  reduced EW (log(EW/wave)-3)
C     11  rejection flag
C     12  DISABLED
C     13  abundance error due to the atmospherical parameters (dex) Cayrel (Teff + sigma(Teff))
C     14  abundance error due to the atmospherical parameters (dex) Cayrel (Teff - sigma(Teff))
C     15  abundance error ---> Teff + sigma(Teff)
C     16  abundance error ---> Teff - sigma(Teff)
C     17  abundance error ---> logg + sigma(logg)
C     18  abundance error ---> logg - sigma(logg)
C     19  abundance error ---> vt + sigma(vt)
C     20  abundance error ---> vt + sigma(vt)
C     21  theoretical EW (mA)





C--------------------------------------------------------------------- DECLARATIONS - I

      
      character    dlist*100,st*10,st2*50,flist*30
      character    star*40,separ*1,xstar*40,jcar*1
      
      character    fla1*60,outl*60,outlp*60,outlm*60
      character    outp*60,inp*60,outabu*60
      character    lab1*55,lab2*55,lab3*30,lab4*55,lab5*10
      character    lab6*25,lab7*30,lab8*30,lab9*30,lab10*13,lab11*5
      character    lab12*91,lab13*12,lab14*33
      character    model*50,model_p*50,model_m*50
      character    labh1*50,labh2*55,labh3*95,labh4*35,labh5*35
      character    labh6*35,labh7*35,labh8*35
      character    at9_dir*80,convf*25
      character    stlog*132,stlog1*76,stlog2*110,stlog3*41
      character    linec*200


      integer       INL, minnfe, minl, errfit,plot,verbose
      integer       linei
      real*4        eplever, maxsig


C--------------------------------------------------------------------- value of INL
C
C --- INL = maximum dimension of the lines matrix
C ---      if your input files ****.in include a larger number
C ---      of lines, change INL and recompile GALA
        
      parameter    (INL=1200)  
      
C--------------------------------------------------------------------- DECLARATIONS - II

      integer      status,statusp,statusm,access,cod1,sd,sd2
      integer      rj,smax,iter,epot,grc,vtc,metal,paropt,error
      integer      refine,guess,uncer,interz
      integer      temp,count0,tinput,tinput0,count2,count3
      integer      glam,dim,dim2,dim3,dim_all,dim_marq
      integer      tc(INL),dim3p,dim3m      
      integer      iee,num,ie,im,ir,id,ih,ijj,ig,il,nn,it,in
      integer      ix,or,ich,ij,ik
      integer      t_new,t
      integer      nfe1,nfe2,nti1,nti2,ntot
      integer      k,i,f,j,jj,nc,xj,xy
      integer      elem(INL,4),num_lin,jx
      integer      xx,yy,stepteff0  
      integer      altnn
      integer      method,pday
      integer      jkk1,jkk3,jk1,jk2,nx,n_line,ll,nlay
      
      real*4       stepgr,g,gr,g_or,g_new,alfa,alfaout
      real*4       flerr1,flerr2
      real*4       val,ewmin,ewmax,stepteff,stepvt,qiron
      real*4       met,vmic,fe1,fe2,qiron2   
      real*4       xwl,xcod,xer(INL),xer0
      real*4       mean,sigf,mean2,sigf2,m,m0
      real*4       n_mean,n_sigf
      real*4       meanw,sigw
      real*4       meanti,meanti2,sigti,sigti2
      real*4       caep,eaep,caew,eaew,s,cbep,cawl,cbwl,eawl
      real*4       mjn,dmj,modnew,mx,ebwl
      real*4       gc(INL),mc(INL),vc(INL)
      real*4       vecp(INL),vecm(INL),vec0(INL),vec_err(INL)
      real*4       wl(INL),ew(INL),gf(INL),ep(INL),vec(INL)
      real*4       cod(INL),ewr(INL),flag(INL),erew(INL)
      real*4       eup(INL),elo(INL),ewrr(INL)
      real*4       ep0(INL),ewr0(INL),aberr0(INL)
      real*4       ewerr0(INL),wl1(INL)
      real*4       el,ab0(INL),ab1(INL),ewtheo(INL)
      real*4       v,vt_new,vt_or,difg,v_new
      
      
      real*4       df,erg,par_vmin,g_new2
      real*4       aberr1(INL),ewerr1(INL)
      real*4       ew1(INL),ewr1(INL),ep1(INL),w1(INL)
      real*4       ewrr1(INL),dist(INL),dist2(INL),thr,thr0,thr1
      real*4       dcod,oelem,errmin
      real*4       eper(INL),eper1(INL)
      real*4       codeg,wave,eqw,eqwr
      real*4       ginput,minput,vinput
      real*4       ginput0,minput0,vinput0
      real*4       codeg2,x
      
      
      real*4       matrix(INL,21)
      real*4       xtest,step_true(3,2),store_slope(3)
      real*4       g_step,xmin,testgr(6,4),testv(4)
      real*4       v_old,supersl,delta_ep, maxep,minep
      
      real*4       verguenza(INL),verguenza_m,verguenza_s
      
      real*4       ab_jkk(INL),ep_jkk(INL),aberr_jkk(INL)
      real*4       ewerr_jkk(INL),jack_ew(INL),jack_wl(INL)
      real*4       jack_ep(INL),ewr_jkk(INL),mean_jkk,sig_jkk
      real*4       wl_jkk(INL)
      
      
      real*4       cfgr0,cfgr,gyg,g_new0
      real*4       crel_a,crel_b,crel_c,crel_a0,crel_b0,crel_c0
      
      
      real*4       spear_ew,spear_ep,spear_wl,prob_wl
      real*4       par_t,par_v,par_t0,par_v0
      real*4       ebep,cbew,ebew,probd
      real*4       zd,prob_ew,rs,prob_ep,par_tmin,ty,par_vinit
   
      
      real*4       caep_t,cbep_t,eaep_t,ebep_t
      real*4       caew_t,cbew_t,eaew_t,ebew_t
      real*4       cawl_t,cbwl_t,eawl_t,ebwl_t
      real*4       jack_teff,jack_vt,jack_wave
      real*4       c1,c2,c3,c4
      
      real*4       xd(2),yd(2),c_or,c_at,c_avt,c_ag, c_a,c_b
      real*4       uncer_t0,uncer_t,uncer_vt,uncer_g
      real*4       param_p(5),param_0(5),param_m(5),covar_p,alfax(INL)
      real*4       mean_p,dif_p,mean2_p,dif2_p
      real*4       ab0_p(INL),ab0_m(INL),mean_m,mean2_m,dif_m,dif2_m
      real*4       mean_tp,mean_tm,mean_gp,mean_gm,mean_vp,mean_vm
      real*4       mean_tp2,mean_tm2,mean_gp2,mean_gm2,mean_vp2,mean_vm2
      real*4       dift_p,dift_m,dift_p2,dift_m2
      real*4       difg_p,difg_m,difg_p2,difg_m2
      real*4       difv_p,difv_m,difv_p2,difv_m2
      
      real*4       mod_dmp(INL,5)
      real*4       jack_grav1(INL),jack_grav2(INL), jack_grav3(INL)
      real*4       jack_dif(INL),jack_logg
      real*4       abg_jkk1(INL),abg_jkk2(INL)
      real*4       jkk_m2,jkk_s2,erg_jkk1(INL),erg_jkk2(INL)
      real*4       mean_jk1,mean_jk2,sig_jk1,sig_jk2
      real*4       erg_jkk_fe1(INL),erg_jkk_fe2(INL)
      real*4       abg_jkk_fe1(INL),abg_jkk_fe2(INL)
      real*4       elg_jkk1(INL)
      real*4       epmin,epmax,difep
      
      integer      njkk1,njkk2,txxx
      
      real*4       grxxx,gg,vv,difg0,difg1
      
      real*4       ep_2(INL),ewr_2(INL),aberr_2(INL),eup_2(INL)
      real*4       elo_2(INL),ewerr_2(INL),errmin_2
      
      real*4       gammar,gammas,gammaw,alp,expot,w,eww,eww2,err,gflog
      integer      tt,mm,guess2,x_err,t_mp,x_uncer
      
      
      real*4 dfgm, yy1, yy2, igg, logg_n1, logg_n2
      real*4 tgrid(33),marcs_tmp(33,9),tgrid_n1(33),tgrid_n2(33)
      real*4 dt0,dp0,dt1,dt2,tbest1,tbest2,tbest3,tbest4
      real*4 min_t_n1,max_t_n1,teff_n1,teff_n2,vt
      real*4 t_null,vt_null,g_null,fe
      
      
      
      
      !integer npt,lnb,l,d
      !real*4 x1(INL),x2(INL),x3(INL),x4(INL),vs(INL)
      !real*4 t1,t2,t3,t4,q1,q2,qs,dd,md0
      !real*4 dg,er(INL),ws(INL)
      !real*8 val1, val2
      !real*4 sm,mt,mt0
      
      
      integer ii,geometry,teff     
 

      real*4 ross,valm,dif1,dftm,logg0,valg,valt
      real*4 vt0,met0,gr0,gsp,alf0
      real*4 damp1(INL),damp2(INL),damp3(INL)
      real*4 bark(INL),kurt,kurg,marcsg,kurt0(INL),kurg0(INL)
      real*4 par1,par2,dis_tg(INL),kurl0(INL)
      integer teff0,kurline,kuriter,marcsline,marcst
      integer nline,munit,kurline0,k0
      character metalc*5,metalc2*5,ink1*1,ink2*6,ink3*3,alfac*5
      character odf*50,kapros*50,kapros2*5
      character outmod*200,cara*110,gridm*150,inmod*150
      character munit_c*12,outlog*150,dance1*13,dance2*13
      
      real*4 g_class,v_class,anull
      integer t_class,tnumber1,tnumber2,modxxx
      
      real*4 abtp(INL),abtm(INL),abgp(INL)
      real*4 abgm(INL),abvp(INL),abvm(INL)
      
      real*4 dmin, dist_mod,t_best0,g_best0,gnumber1,gnumber2
      real*4 vnumber1,vnumber2,mean0,mean0_2
      
      real*4 merit,guess_tmp(4),solar
      real*4 bunker_vt(100,2),wlg0(INL),meritp
      
      real*4 mg_ab,si_ab,ca_ab,ti_ab,code,ab,ab_alfa(14)
      real*4 metx,alfx
      
      !------
      real*4  sun_atlas(99),sun_marcs(99),vtx(5)
      real*4  mj(100,100)
      integer dim_grid(2)
      
      !------
      
      
      integer b,b0,iexit,iopti,conv
      integer ym
      
C--------------------------------------------------------------------- ELEMENTS


      character*2  elemx(99),xelem,xioni
          
      data elemx/
     &           'H ','He','Li','Be','B ','C ','N ','O ','F ',
     &  	 'Ne','Na','Mg','Al','Si','P ','S ','Cl','Ar',
     &  	 'K ','Ca','Sc','Ti','V ','Cr','Mn','Fe','Co',
     &  	 'Ni','Cu','Zn','Ga','Ge','As','Se','Br','Kr',
     &  	 'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh',
     &  	 'Pd','Ag','Cd','In','Sn','Sb','Te','I ','Xe',
     &  	 'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu',
     &  	 'Gd','Tb','Dy','Ho','Er','Tm','Yb','Lu','Hf',
     &  	 'Ta','W ','Re','Os','Ir','Pt','Au','Hg','Tl',
     &  	 'Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     &  	 'Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es'/	
     
C--------------------------------------------------------------------- ALLOWED MODEL GRIDS
      
      integer NMODA,NMODM
      
      parameter    (NMODM=1)     !number of MARCS model grids
      parameter    (NMODA=12)     !number of ATLAS model grids
      
      character*30 atmos_marcs(NMODM),atmos_atlas(NMODA)
      
      data atmos_marcs/'marcs'/
      !
      data atmos_atlas/'atlas9',              ! keyword for ATLAS9 models by F.C.
     &  	       'apogee_cm150',        ! keywords for APOGEE-ATLAS9 models
     &	 	       'apogee_cm125',
     &	 	       'apogee_cm100',
     &	 	       'apogee_cm075',
     &	 	       'apogee_cm050',
     &	 	       'apogee_cm025',
     &	 	       'apogee_cp000',
     &	 	       'apogee_cp025',
     &	 	       'apogee_cp050',
     &	 	       'apogee_cp075',
     &  	       'apogee_cp100'/
      
      
      

C--------------------------------------------------------------------- COMMON BLOCKS !!!

      
     
      common /alice1/ rj,smax,iter,epot,grc,vtc,metal,paropt,
     1                ewmin,ewmax,stepgr,
     2                stepteff,stepvt,error,refine,guess,guess2,
     3                step_true,store_slope,method,uncer,qiron,
     4                minnfe,eplever,maxsig,minl,qiron2,errfit,interz,
     5                kuriter,plot,verbose
      
      common /alice2/ dim,dim2,dim3,
     1                mean,mean2,nfe1,nfe2,elem,nti1,nti2,num_lin,
     2                dim_all,dim_marq,num,mean2_p,mean2_m,mean_m,
     3                mean_p,sigf,sigf2,
     4                mean_tp,mean_tm,mean_tp2,mean_tm2,
     5                mean_gp,mean_gm,mean_gp2,mean_gm2,
     6                mean_vp,mean_vm,mean_vp2,mean_vm2,
     7                xer0
     

      common /alice3/ tinput,ginput,minput,vinput,count2,altnn,count3
      
      common /alice4/ caep,eaep,cbep,caew,eaew,cbew,spear_ew,spear_ep,
     1                prob_ew,prob_ep,jack_teff,jack_vt,jack_logg,
     2                par_t,par_v,merit,difep,cawl,cbwl,eawl,
     3                spear_wl,prob_wl,jack_wave,ebwl
      
      common /alice5/ matrix, mod_dmp,xelem,xioni,iexit,pday
      
      common /alice6/ c_at,c_avt,c_ag, uncer_t,uncer_vt,uncer_g,x_err,
     1                param_p,param_0, param_m,uncer_t0,x_uncer,covar_p
            
	    
      common /alice7/txxx,grxxx,modxxx
      
      common /alice8/t_null,vt_null,g_null
      
      common /alice9/dim_grid,mj,sun_atlas,ym,conv
      
      common /alice10/at9_dir,odf,kapros,gridm,outmod,outlog,model
      
      
      
