      program extract

C     13/05/2012 (AM)     
C
C     The program reads the Kurucz linelist (in the standard Kurucz format and
C     stored in the file 'master_linelist.tmp') and extracts the lines in 'input.dat'.
C     The file 'output.dat' includes the input lines in the format requested 
C     by width9_gala
C

      implicit none
      
      character REF*4,LABEL*10,LABELP*10
      
      integer n,ntot
      integer NBLO,NBUP
      integer ISO1,ISO2
      integer OTHER1,OTHER2
      integer NELION,nelb,jc
      
      real*4 w,codeg,mindel
      real*4 check(300000)
      real*4 WL,GFLOG,E,EP,CODE,XJ,XJP
      real*4 GAMMAR,GAMMAS,GAMMAW,X1,X2
      real*4 LANDE,LANDEG,ISOSHIFT,alfab
      real*4 EP_EV
      real*4 wavel(300000),codel(300000),gfl(300000)      
      real*4 wavel2,delgf
      
      dimension label(2),labelp(2),other1(2),other2(2)
      
      
      open(1,file='input.dat',status='unknown')
      open(2,file='master_linelist.tmp',status='unknown',RECL=160)
      open(3,file='output.dat',status='unknown')
      

889   read(1,*,end=888)w,codeg
      jc=1
      w=w/10.
      mindel=1000.
      
      
C-----------------------------------------------------------------------
	
610    	read(2,11,end=600)WL,GFLOG,CODE,E,XJ,LABEL,EP,XJP,LABELP,
     1GAMMAR,GAMMAS,GAMMAW,REF,NBLO,NBUP,ISO1,X1,ISO2,X2,OTHER1,
     2OTHER2,LANDE,LANDEG,ISOSHIFT,alfab
     	
     	
	if(code.eq.codeg)then
	 check(jc)=abs(w-WL)
	 wavel(jc)=WL
	 codel(jc)=CODE
	 gfl(jc)=GFLOG
	 jc=jc+1
	endif
		
	goto 610
600     continue 

      
      jc=jc-1
      call sort4(jc,check,wavel,codel,gfl)
      
      delgf=gfl(1)
      wavel2=wavel(1)
      if(wavel(1).eq.wavel(2).and.codel(1).eq.codel(2))then
         delgf=max(gfl(1),gfl(2))
         if(gfl(1).eq.delgf)wavel2=wavel(1)
         if(gfl(2).eq.delgf)wavel2=wavel(2)     	 
      endif
      	 
      rewind(2)
      
C-----------------------------------------------------------------------
      
760   read(2,11,end=750)WL,GFLOG,CODE,E,XJ,LABEL,EP,XJP,LABELP,
     1GAMMAR,GAMMAS,GAMMAW,REF,NBLO,NBUP,ISO1,X1,ISO2,X2,OTHER1,
     2OTHER2,LANDE,LANDEG,ISOSHIFT,alfab
      

      if(WL.eq.wavel(1).and.CODE.eq.codeg.and.GFLOG.eq.delgf)then	
        EP_EV = (min (E,EP) )* 1.23981E-4    
        write(3,140)WL*10.,CODE,GFLOG,EP_EV,GAMMAR,GAMMAS,GAMMAW,alfab
        n=n+1
      endif
                 
       	  
      goto 760
750   continue    

C-----------------------------------------------------------------------
  
      rewind(2)
      ntot=ntot+1
      goto 889
888   continue


      close(1)
      close(2) 
      close(3)
      
           
	   
11    format(F11.4,F7.3,F6.2,F12.3,F5.1,1X,A8,A2,F12.3,F5.1,1X,A8,A2,
     1 F6.2,F6.2,F6.2,A4,I2,I2,I3,F6.3,I3,F6.3,A8,A2,A8,A2,2I5,I6,F6.3)    
         
140   format(F10.3,3X,F6.2,3X,F8.3,3X,F6.3,3X,4(F6.3,2X))
     
      end




C----------------------------------------------------------- subroutine to sort 4 vectors


      subroutine sort4(npt,x1,x2,x3,x4)
      parameter (NM=10000)
      integer npt
      real*4 x1(NM),x2(NM),x3(NM),x4(NM)
      real*4 t1,t2,t3,t4
      real*8 val1, val2
            
                   
      val1 = 1.0/0.69314718
      val2 = 1.0e-5
      lognb2 = int(dlog(dfloat(npt))*val1+val2)
      m = npt
      
      do nn=1,lognb2
         m = m/2
         k = npt - m
         do j=1,k
            i = j
3           continue
            l = i + m
            if(x1(l).lt.x1(i))then
               t1 = x1(i)	
	       t2 = x2(i)     
	       t3 = x3(i)   
	       t4 = x4(i) 
	       x1(i)=x1(l)
	       x2(i)=x2(l)
	       x3(i)=x3(l)
	       x4(i)=x4(l)	       
	       x1(l)=t1
	       x2(l)=t2
	       x3(l)=t3
	       x4(l)=t4
               i = i - m
               if(i.ge.1)goto 3
            endif
         enddo
      enddo
            
      return      
      end subroutine
     



