      subroutine fit_exy(x,y,n,ex,ey,slope,zp,eslope,ezp)
      
      implicit none
      
      integer j,k,NMAX,n,nn,altnn
      parameter(NMAX=5000)
      real*4 m,s,varx,vary,sc
      real*4 x(NMAX),y(NMAX),ex(NMAX),ey(NMAX)
      real*4 slope,zp,eslope,ezp
      real*4 xnew(NMAX),exnew(NMAX)
      real*4 ynew(NMAX),eynew(NMAX),ww(NMAX)
      real*4 d,offset,vet(6),ch(6)
      real*4 mini,maxi,r2,PI
      real*4 slope_min,slope_max,zp_min,zp_max
      real*4 d1,d2,sw,aa,chi2
      real*4 zbr,cxy,brn
      
      common /fitblock/xnew,ynew,exnew,eynew,ww,aa,offset,nn
      external cxy
      
      
      mini=1e-3
      maxi=1e30
      PI=3.14159265
      
      altnn=0.
      slope=0.
      zp=0.
      eslope=0.
      ezp=0.
      
      call calsig(x,n,m,s)
      varx=s**2
      call calsig(y,n,m,s)
      vary=s**2
      
      if(n.gt.NMAX)altnn=1
      nn=n
      sc=(varx/vary)**0.5
      
      
      do j=1,n
        xnew(j)=x(j)
        ynew(j)=y(j)*sc
	exnew(j)=ex(j)
	eynew(j)=ey(j)*sc
	ww(j)=(exnew(j)**2+eynew(j)**2)**0.5
      enddo
      
      call fit_ey(x,ynew,n,ww,1,slope,d,d,d)
      
      offset=0.
      vet(1)=0.
      vet(2)=atan(slope)
      vet(4)=0.
      vet(5)=atan(slope)
      vet(6)=1.571
      
      do j=4,6
        ch(j)=cxy(vet(j))
      enddo
      
      call mnb(vet(1),vet(2),vet(3),ch(1),ch(2),ch(3),cxy)
      
      chi2=brn(vet(1),vet(2),vet(3),cxy,mini,slope)
      chi2=cxy(slope)
      zp=aa
      
      r2=0      
      do j=1,n
        r2=r2+ww(j)
      enddo      
      r2=1/r2
      
      slope_max=maxi
      slope_min=maxi
      
      offset=chi2+1
      
      do j=1,6
        if(ch(j).gt.offset)then
	  d1=mod(abs(vet(j)-slope),PI)
	  d2=PI-d1
	  if(vet(j).lt.offset)then
	    sw=d1
	    d1=d2
	    d2=sw
	  endif
	  if(d1.lt.slope_max)slope_max=d1
	  if(d2.lt.slope_min)slope_min=d2
	endif
      enddo
      
      if(slope_max.lt.maxi)then
       slope_max=zbr(cxy,slope,slope+slope_max,mini)
     &          -slope
       zp_max=aa-zp
       slope_min=zbr(cxy,slope,slope-slope_min,mini)
     &          -slope
       zp_min=aa-zp
       eslope=sqrt(0.5*(slope_max**2+slope_min**2))/
     &            (sc*cos(slope)**2)
       ezp=sqrt(0.5*(zp_max**2+zp_min**2)+r2)/sc       
      else
       eslope=maxi
       ezp=maxi
      endif
      
      
      zp=zp/sc
      slope=tan(slope)/sc
      
      end subroutine


C-------------------------------------------------------------

      function cxy(num)
      
      implicit none
      
      integer j,NMAX,nn
      parameter(NMAX=5000)
      real*4 num,offset,aa,maxi
      real*4 xnew(NMAX),exnew(NMAX)
      real*4 ynew(NMAX),eynew(NMAX),ww(NMAX)
      real*4 b,avex,avey,sumw,cxy
            
      common /fitblock/xnew,ynew,exnew,eynew,ww,aa,offset,nn
      
      maxi=1e30
      
      b=tan(num)
      avex=0.
      avey=0.
      sumw=0.
      
      
      do j=1,nn
        ww(j)=(b*exnew(j))**2 + (eynew(j))**2
	if(ww(j).eq.0)ww(j)=maxi
	if(ww(j).ne.0)ww(j)=1/ww(j)
	sumw=sumw+ww(j)
	avex=avex+ww(j)*xnew(j)
	avey=avey+ww(j)*ynew(j)
      enddo
      
      avex=avex/sumw
      avey=avey/sumw
      aa=avey-b*avex
      cxy=-offset
      
      do j=1,nn
        cxy=cxy+ww(j)*(ynew(j)-aa-b*xnew(j))**2
      enddo
      
      end 


C-------------------------------------------------------------
    
    
      subroutine mnb(a1,a2,a3,f1,f2,f3,func)
      
      real*4 a1,a2,a3,f1,f2,f3,func
      real*4 cost1,gma1,mini
      real*4 dum,fu,q,r,u,limit
      external func
      
      
      cost1=1.618034
      mini=1.e-20
      gma1=100
      
      
      f1=func(a1)
      f2=func(a2)
      if(f2.gt.f1)then
        dum=a1
        a1=a2
        a2=dum
        dum=f2
        f2=f1
        f1=dum
      endif
      
      a3=a2+cost1*(a2-a1)
      f3=func(a3)

100   continue      
      
      if(f2.ge.f3)then
        r=(a2-a1)*(f2-f3)
        q=(a2-a3)*(f2-f1)
        u=a2-((a2-a3)*q-(a2-a1)*r)/(2.*sign(max(abs(q-r),mini),q-r))
        limit=a2+gma1*(a3-a2)
        if((a2-u)*(u-a3).gt.0.)then
          fu=func(u)
          if(fu.lt.f3)then
            a1=a2
            f1=f2
            a2=u
            f2=fu
            return
          else if(fu.gt.f2)then
            a3=u
            f3=fu
            return
          endif
          u=a3+cost1*(a3-a2)
          fu=func(u)
	  
        else if((a3-u)*(u-limit).gt.0.)then
          fu=func(u)
          if(fu.lt.f3)then
            a2=a3
            a3=u
            u=a3+cost1*(a3-a2)
            f2=f3
            f3=fu
            fu=func(u)
          endif
	  
        else if((u-limit)*(limit-a3).ge.0.)then
          u=limit
          fu=func(u)
        else
          u=a3+cost1*(a3-a2)
          fu=func(u)
        endif
        a1=a2
        a2=a3
        a3=u
        f1=f2
        f2=f3
        f3=fu
        goto 100
      endif
      
      return      
      end subroutine
      
 

C-------------------------------------------------------------
    
          
      
      function brn(AX,BX,CX,F,TOL,XMIN)
      
      implicit real*4 (A-H,O-Z)
      
      integer j,maxit
      real*4 CGOLD,ZEPS
      
      maxit=100
      CGOLD=0.3819660
      ZEPS=1.0E-10
      
      A=min(AX,CX)
      B=max(AX,CX)
      V=BX
      W=V
      X=V
      E=0.
      FX=F(X)
      FV=FX
      FW=FX
      
      do j=1,maxit
      
        XM=0.5*(A+B)
        TOL1=TOL*abs(X)+ZEPS
        TOL2=2.*TOL1
	
        if(abs(X-XM).le.(TOL2-.5*(B-A)))goto 300
	
        if(abs(E).gt.TOL1) then
	
          R=(X-W)*(FX-FV)
          Q=(X-V)*(FX-FW)
          P=(X-V)*Q-(X-W)*R
          Q=2.*(Q-R)
          if(Q.gt.0.) P=-P
          Q=abs(Q)
          ETEMP=E
          E=D
          if(abs(P).ge.abs(.5*Q*ETEMP).or.P.le.Q*(A-X).or.
     &        P.ge.Q*(B-X)) goto 100
          D=P/Q
          U=X+D
          if(U-A.LT.TOL2 .or. B-U.LT.TOL2) D=sign(TOL1,XM-X)
          goto 200
	  
        endif
	
100     if(X.ge.XM) then
          E=A-X
        else
          E=B-X
        endif
        D=CGOLD*E
	
	
200     if(abs(D).ge.TOL1) then
          U=X+D
        else
          U=X+sign(TOL1,D)
        endif
        FU=F(U)
        if(FU.le.FX) then
          if(U.ge.X) then
            A=X
          else
            B=X
          endif
          V=W
          FV=FW
          W=X
          FW=FX
          X=U
          FX=FU
        else
          if(U.LT.X) then
            A=U
          else
            B=U
          endif
          if(FU.le.FW .or. W.eq.X) then
            V=W
            FV=FW
            W=U
            FW=FU
          else if(FU.le.FV .or. V.eq.X .or. V.eq.W) then
            V=U
            FV=FU
          endif
        endif
      
      enddo

      altnn=1
      return
      
300   XMIN=X
      brn=FX
      
      return
      
      end


C-------------------------------------------------------------
         

      function  zbr(func,X1,X2,TOL)

C     Return the root of the function FUNC using the Brent method.
C     The root of the function lies between X1 and X2.
C     TOL is the accuracy for the numerical convergence.
C     The final value is stored in ZBR
C

      
      implicit real*4 (A-H,O-Z)
      
      integer maxit,eps,j
      
      maxit=100
      eps=3.e-8
      
      A=X1
      B=X2
      FA=func(A)
      FB=func(B)
      
       
      if(FB*FA.gt.0.)then
        altnn=1
	return
      endif
      
      
      FC=FB
      
      do j=1,maxit
      
        if(FB*FC.gt.0.) then
          C=A
          FC=FA
          D=B-A
          E=D
        endif
	
        if(abs(FC).lt.abs(FB)) then
          A=B
          B=C
          C=A
          FA=FB
          FB=FC
          FC=FA
        endif
	
        TOL1=2.*eps*abs(B)+0.5*TOL
        XM=.5*(C-B)
	
        if(abs(XM).le.TOL1 .or. FB.eq.0.)then
          zbr=B
          return
        endif
	
        if(abs(E).GE.TOL1 .and. abs(FA).gt.abs(FB)) then
          S=FB/FA
          if(A.eq.C) then
            P=2.*XM*S
            Q=1.-S
          else
            Q=FA/FC
            R=FB/FC
            P=S*(2.*XM*Q*(Q-R)-(B-A)*(R-1.))
            Q=(Q-1.)*(R-1.)*(S-1.)
          endif
          if(P.gt.0.) Q=-Q
          P=abs(P)
          if(2.*P .lt. min(3.*XM*Q-abs(TOL1*Q),abs(E*Q))) then
            E=D
            D=P/Q
          else
            D=XM
            E=D
          endif
        else
          D=XM
          E=D
        endif
	
        A=B
        FA=FB
	
        if(abs(D) .gt. TOL1) then
          B=B+D
        else
          B=B+sign(TOL1,XM)
        endif
	
        FB=func(B)

      enddo
      
      altnn=1
      return
      zbr=B
      
      return
      end
