C----------------------------------------------------------------------------
cc      
cc    mean, sigma
cc 
      subroutine calsig(v,d,m,s)
      
      parameter (NMAX=5000)
      real*4 v(NMAX),m,s,sm,mt,mt0
      integer d,j
      
     
      sm=0.
      mt=0.       
      do j=1,d,1
        sm=sm+v(j)
      enddo

      m=sm/d
      do j=1,d,1
        mt0=((v(j)-m)**2)/(d-1)
        mt=mt+mt0
      enddo      
      s=mt**0.5
      
      if(d.eq.1)s=0.     
       
      end subroutine


C----------------------------------------------------------------------------    
cc      
cc    median, sigma
cc
 
      subroutine calsig2(v,d,md0,qs)
      parameter (NMAX=5000)
      real*4 v(NMAX),md0,q1,q2,qs
      real*4 df,dg
      integer d,j,jj
      

      call sort1(d,v)
      if(mod(d,2).eq.0)then
         md0=( v(d/2) + v(d/2 + 1) ) / 2         !EVEN
	 
	   df=abs((0.25*d) - int(0.25*d))
	   if(df.ge.0.5)q1=v(1 + int(0.25*d))
	   if(df.lt.0.5)q1=v(int(0.25*d))
	   
	   dg=abs((0.75*d) - int(0.75*d))
	   if(dg.ge.0.5)q2=v(1 + int(0.75*d))
	   if(dg.lt.0.5)q2=v(int(0.75*d))
	   
         qs=(q2-q1)/2	 	 
      else
	 md0=v((d+1)/2)
	 
	   df=abs((0.25*d) - int(0.25*d))
	   if(df.ge.0.5)q1=v(1 + int(0.25*d))
	   if(df.lt.0.5)q1=v(int(0.25*d))
	   
	   dg=abs((0.75*d) - int(0.75*d))
	   if(dg.ge.0.5)q2=v(1 + int(0.75*d))
	   if(dg.lt.0.5)q2=v(int(0.75*d))
	   
         qs=(q2-q1)/2	 
      endif	
      
      if(d.eq.1)qs=0.     
     
      end subroutine

C----------------------------------------------------------------------------
cc      
cc    weighted mean, sigma
cc 
      subroutine calsigw(v,d,er,m,s)
      
      parameter (NMAX=5000)
      real*4 v(NMAX),m,s,sm,mt,mt0,er(NMAX),w(NMAX)
      real*4 dd
      integer d,j
      
      do j=1,d,1
       w(j)=1/(er(j)**2)
      enddo
      
      sm=0.
      mt=0.   
      dd=0. 
      mt=0.   
      do j=1,d,1
       sm=sm+v(j)*w(j)
       dd=dd+w(j)
      enddo

      m=sm/dd
      do  j=1,d,1
       mt0=mt0+w(j)*(v(j)-m)**2
       mt=mt+w(j)
      enddo   
         
      !s=(1/mt)**0.5
      s=sqrt(mt0/mt)
      if(d.eq.1)s=0.     
       
      end subroutine

C----------------------------------------------------------------------------
cc      
cc    weighted mean
cc 
      subroutine calsigw2(v,d,er,m)
      
      parameter (NMAX=5000)
      real*4 v(NMAX),m,s,sm,mt,mt0,er(NMAX),w(NMAX)
      real*4 dd
      integer d,j
      
      do j=1,d,1
       w(j)=1/(er(j)**2)
      enddo
      
      sm=0.
      mt=0.   
      dd=0. 
      mt=0.   
      do j=1,d,1
       sm=sm+v(j)*w(j)
       dd=dd+w(j)
      enddo

      m=sm/dd
       
      end subroutine
