CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine guesspar(star,t,g,met,v,alfa)


C   
C     The subroutine checks the input guess parameters and finds 
C     a new set of guess parameters for the analysis.The employed 
C     parameter steps are 500 K (Teff), 0.5 (log g) and 0.5 km/s (vt). 
C
C     The procedure is repeated N times, where N is specified by the 
C     kewyord 'guess' in the file 'autofl.param'

      
      implicit none      
      include 'Declare.f'        
	
      guess_tmp(1)=0.
      guess_tmp(2)=0.
      guess_tmp(3)=0.
      guess_tmp(4)=0.
      
	
	
      if(verbose.ge.2)
     &write(*,*)'-----------------------------------------------
     &----------GUESS WORKING BLOCK'
      
      
      call xabu(star,t,g,met,v,alfa,2)    
	t=txxx
	g=grxxx
      if(paropt.eq.0)par_t0=caep
      if(paropt.eq.1)par_t0=spear_ep
      
      mm=1	
      
      if(verbose.ge.2)write(*,*)'iteration ',mm   
      goto 103
      	
C-------------------------------------------------------- Temperature


102   continue

      guess_tmp(1)=real(tt)
      guess_tmp(2)=g
      guess_tmp(3)=met
      guess_tmp(4)=v

     
      if(verbose.ge.2)write(*,*)'iteration ',mm 
      glam=0
      goto 103
      
103   continue
      
      if(epot.eq.0)goto 202
      
      if(par_t0.gt.0)t_new=t+500
      if(par_t0.lt.0)t_new=t-500
    
      if(t_new.lt.3500)t_new=3500
      
      
      call xabu(star,t_new,g,met,v,alfa,2)    
	t_new=txxx
	g=grxxx
      
      
      
      if(ym.eq.2.and.t.eq.3500.and.t_new.eq.3500)then
        if(verbose.eq.3)
     &     write(*,404)'Approximate Teff for which slope=0',t	
        if(paropt.eq.0)par_t=caep
        if(paropt.eq.1)par_t=spear_ep
	
        t=tt
	if(paropt.eq.0)par_v0=caew
	if(paropt.eq.1)par_v0=spear_ew
        goto 202     
      endif
      
      
      if(t.ne.t_new)then
      
       if(par_t0.gt.0.and.par_t.gt.0)then
        par_t0=par_t
	t=t_new
	goto 103
       elseif(par_t0.lt.0.and.par_t.lt.0)then
        par_t0=par_t
	t=t_new
	goto 103
  
       else
      
        
         tt=t-(t_new-t)*par_t0/(par_t-par_t0)       
         ty=float(tt)/100-int(tt/100)
         if(ty.le.abs(stepteff/100))tt=int(tt/100)*100
         if(ty.gt.abs(stepteff/100))tt=int(tt/100)*100+abs(stepteff)
	
        if(verbose.eq.3)
     &     write(*,404)'Approximate Teff for which slope=0',tt
      
	
	call xabu(star,tt,g,met,v,alfa,2)    
	t=txxx
	g=grxxx
        t=tt
	
	if(paropt.eq.0)par_v0=caew
        if(paropt.eq.1)par_v0=spear_ew
        goto 202
	
       endif
      
      else
     
	 tt=t
	 if(verbose.eq.3)
     &     write(*,404)'Approximate Teff for which slope=0',tt
	
	call xabu(star,t,g,met,v,alfa,2)    
	t=txxx
	g=grxxx
        
	t=tt
	if(paropt.eq.0)par_v0=caew
        if(paropt.eq.1)par_v0=spear_ew
	
        goto 202

      endif
      
       
C--------------------------------------------------------  Microturbulent velocity
   
202   continue

      if(vtc.eq.0)goto 302
      
      if(par_v0.gt.0)v_new=v+0.5
      if(par_v0.lt.0)v_new=v-0.5
    
    

      call xabu(star,t,g,met,v_new,alfa,2)    
	t=txxx
	g=grxxx
      
      if(v_new.ge.0.and.v_new.le.3)then
      
       if(par_v0.gt.0.and.par_v.gt.0)then
        par_v0=par_v
	v=v_new
	goto 202
       elseif(par_v0.lt.0.and.par_v.lt.0)then
        par_v0=par_v
	v=v_new
	goto 202
       else	
        vv=v-(v_new-v)*par_v0/(par_v-par_v0)
	
	if( (10.*vv-int(10.*vv)).le.0.5 )vv=0.1*int(10*vv)
	if( (10.*vv-int(10.*vv)).gt.0.5 )vv=0.1*(int(10*vv)+1)
	
	
        if(verbose.eq.3)
     &     write(*,405)'Approximate Vt for which slope=0',vv
       
       
	call xabu(star,t,g,met,v,alfa,2)    
	t=txxx
	g=grxxx
        difg0=(mean-mean2)
       
        v=vv
	
	if(grc.eq.0.or.grc.eq.2)then
          if(paropt.eq.0)par_t0=caep
	  if(paropt.eq.1)par_t0=spear_ep
	  mm=mm+1
	  if(mm.eq.4)goto 200
	  if(mm.ne.4.and.grc.eq.2)then
	    call grav_ph(star,t,g)
	    goto 102
	  endif 
	  if(mm.ne.4.and.grc.eq.0)goto 102
	endif 
	
	if(grc.eq.1)goto 302
	
       endif
      
      else
        if(verbose.eq.3)
     &     write(*,405)'Approximate Vt for which slope=0',v
        
	
	call xabu(star,t,g,met,v,alfa,2)    
	t=txxx
	g=grxxx
        difg0=(mean-mean2)
	
	if(grc.eq.0.or.grc.eq.2)then
          if(paropt.eq.0)par_t0=caep
	  if(paropt.eq.1)par_t0=spear_ep
	  mm=mm+1
	  if(mm.eq.4)goto 200
	  if(mm.ne.4.and.grc.eq.2)then
	    call grav_ph(star,t,g)
	    goto 102
	  endif 
	  if(mm.ne.4.and.grc.eq.0)goto 102
	endif 
	if(grc.eq.1)goto 302
	
      endif
      
C--------------------------------------------------------   Surface gravity

302   continue
      
      if(grc.eq.0)goto 200

      if(difg0.ge.0.)g_new=g+0.5
      if(difg0.lt.0.)g_new=g-0.5

      if(g_new.lt.0)g_new=g+0.5
      
      call xabu(star,t,g_new,met,v,alfa,2)    
	t=txxx
	g_new=grxxx
      difg=(mean-mean2)
      
      
      
      if(difg0.ne.difg)then
       gg=g-(g_new-g)*difg0/(difg-difg0)
       if(gg.lt.0)gg=0.
       g=gg
      else
       g=0.0
      endif  
      
      if( (10.*g-int(10.*g)).le.0.5 )g=0.1*int(10*g)
      if( (10.*g-int(10.*g)).gt.0.5 )g=0.1*(int(10*g)+1)

      if(verbose.eq.3)
     &   write(*,405)'Approximate g for which FeI=FeII',g
      
      if(g.lt.0)g=0.0
      if(g.gt.5.0)g=5.0
      call loopmet(modnew)
      met=modnew

      
      call xabu(star,t,g,met,v,alfa,2)    
	t=txxx
	g=grxxx
      
      if(paropt.eq.0)par_t0=caep
      if(paropt.eq.1)par_t0=spear_ep
      
      
      
      
      if(guess_tmp(1).eq.tt.and.guess_tmp(2).eq.g.and.
     &   guess_tmp(3).eq.met.and.guess_tmp(4).eq.v)goto 200
      
      mm=mm+1
      if(mm.eq.(guess+1))goto 200
      if(mm.ne.(guess+1))goto 102
      
      
200   continue
      count0=0
      guess2=1
      
      if(verbose.ge.2)then
      
        if(ym.eq.2)write(*,318)'NEW GUESS PARAMETERS',
     &     t,g,met,v
        if(ym.eq.1)write(*,318)'NEW GUESS PARAMETERS',
     &     t,g,met,v
       
       endif
C-------------------------------------------------------------------      
      
      call main(star,t,g,met,v,alfa,count0) 
      
C-------------------------------------------------------------------  FORMATS
      

404   format(A34,7X,I5)
405   format(A32,17X,F4.1)
318   format(A20,1X,I5,2X,F4.1,2X,F5.2,2X,F4.1)


      return
      end
