CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      subroutine iron1(star,nn,el)


      implicit none
      include 'Declare.f'   
      
      altnn=0
      anull=0.0
      outp=star(1:len_trim(star))//'.EW'
      
C---------------------------------------------------------------  outliers rejection (only with nn=1)

      if(nn.eq.1)call reje1(star,n_line,el)
      if(nn.ne.1.and.el.eq.qiron)n_line=dim
      if(nn.ne.1.and.el.eq.qiron2)n_line=dim2            
      if(nn.eq.1.and.el.eq.qiron2)dim2=n_line
      
C--------------------------------------------------------------- 

      do i=1,INL
        wlg0(i)=0.
        ep0(i)=0.
	vec0(i)=0.
	ewr0(i)=0.
	aberr0(i)=0.
	ewerr0(i)=0.
      enddo
      		 
      im=1
      errmin=1000.
      
      
      do ie=1,num_lin
      
	if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1)then
	  wlg0(im)=matrix(ie,1)
	  ep0(im)=matrix(ie,4)
	  vec0(im)=matrix(ie,6)
	  ewr0(im)=matrix(ie,10)
	  aberr0(im)=matrix(ie,7)
	  eup(im)=log10((matrix(ie,2)+matrix(ie,8))/matrix(ie,1))-3  
	  elo(im)=log10((matrix(ie,2)-matrix(ie,8))/matrix(ie,1))-3  
          ewerr0(im)=(abs(ewr0(im)-eup(im))+abs(ewr0(im)-elo(im)))/2	  
          errmin=min(ewerr0(im),errmin)
	  im=im+1	  
	 endif
	
	!------ 
	   n_line=im-1
	!------
	
	
	
	
	!------------------------------------------------------------
	!------------------------------- write the output file ***.EW 
	!------------------------------------------------------------
	if(nn.eq.4)then
	 open(unit=4,file=outp,status='unknown',access='append')
          
     
	  if(matrix(ie,5).eq.el.and.uncer.eq.0)then
	   write(4,603)
     &         matrix(ie,1),matrix(ie,2),matrix(ie,3),matrix(ie,4),
     &         matrix(ie,6),matrix(ie,8),matrix(ie,7),matrix(ie,5),
     &         matrix(ie,11),matrix(ie,21),anull,
     &         anull,anull,anull,anull,anull,anull,anull
     
          endif
	  

	  if(matrix(ie,5).eq.el.and.uncer.eq.1)then
	   write(4,603)
     &         matrix(ie,1),matrix(ie,2),matrix(ie,3),matrix(ie,4),
     &         matrix(ie,6),matrix(ie,8),matrix(ie,7),matrix(ie,5),
     &         matrix(ie,11),matrix(ie,21),matrix(ie,13)-matrix(ie,6),
     &         matrix(ie,14)-matrix(ie,6),anull,anull,anull,anull,
     &         anull,anull
     
          endif


	  if(matrix(ie,5).eq.el.and.uncer.eq.2)then
	   write(4,603)
     &         matrix(ie,1),matrix(ie,2),matrix(ie,3),matrix(ie,4),
     &         matrix(ie,6),matrix(ie,8),matrix(ie,7),matrix(ie,5),
     &         matrix(ie,11),matrix(ie,21),
     &         matrix(ie,13)-matrix(ie,6),matrix(ie,14)-matrix(ie,6),
     &         matrix(ie,15)-matrix(ie,6),matrix(ie,16)-matrix(ie,6),
     &         matrix(ie,17)-matrix(ie,6),matrix(ie,18)-matrix(ie,6),
     &         matrix(ie,19)-matrix(ie,6),matrix(ie,20)-matrix(ie,6)
          endif
	  
	 close(4)
	endif
	!------------------------------------------------------------
      enddo
      
      

      !---check the E.P. leverage (only at the first run)
      epmin=100.
      epmax=-100.
      if(el.eq.qiron.and.nn.eq.1)then
       do i=1,n_line
         if(ep0(i).lt.epmin)epmin=ep0(i)
	 if(ep0(i).gt.epmax)epmax=ep0(i)
       enddo
       difep=epmax-epmin
      endif
      

      
C----------------------------------------------------------------- compute slopes       
      
           
      if(n_line.gt.1)then
        if(errmin.ne.0)call calsigw(vec0,n_line,aberr0,n_mean,n_sigf)
        if(errmin.eq.0)call calsig(vec0,n_line,n_mean,n_sigf)
      endif
      if(n_line.eq.1)then
        n_mean=vec0(1)
	n_sigf=0.0
      endif
      if(n_line.eq.0)then
        n_mean=0.0
	n_sigf=0.0
      endif
      
      if(qiron.eq.el.and.n_line.le.2)then 
       caep=0.
       cbep=0.
       eaep=0.
       ebep=0.
       caew=0.
       cbew=0.
       eaew=0.
       ebew=0. 
       cawl=0.
       cbwl=0.
       eawl=0.
       ebwl=0.   
       jack_vt=0.0
       jack_teff=0.0
       jack_wave=0.0
       spear_ep=0.0
       spear_ew=0.0
       spear_wl=0.0
       prob_ep=0.0
       prob_ew=0.0
       prob_wl=0.0
       goto 69
      endif
      
      if(qiron.eq.el.and.n_line.gt.2)then   
       
       !------ least square fits  
       
       
       if(errfit.eq.0.or.errmin.eq.0)then
        !---linear fit without errors
        call fit_ey(ep0,vec0,n_line,aberr0,0,caep,cbep,eaep,ebep)  
        call fit_ey(ewr0,vec0,n_line,aberr0,0,caew,cbew,eaew,ebew)    	
	call fit_ey(wlg0,vec0,n_line,aberr0,0,cawl,cbwl,eawl,ebwl)
       elseif(errfit.eq.1.and.errmin.ne.0)then
        !---linear fit with errors in y
        call fit_ey(ep0,vec0,n_line,aberr0,1,caep,cbep,eaep,ebep)  
        call fit_ey(ewr0,vec0,n_line,aberr0,1,caew,cbew,eaew,ebew)    	
	call fit_ey(wlg0,vec0,n_line,aberr0,1,cawl,cbwl,eawl,ebwl)
       elseif(errfit.eq.2.and.errmin.ne.0)then
        !---linear fit with errors in x and y for (ABU--EWR)
        call fit_ey(ep0,vec0,n_line,aberr0,1,caep,cbep,eaep,ebep)
        call fit_exy(ewr0,vec0,n_line,ewerr0,aberr0,caew,cbew,eaew,ebew)   
	call fit_ey(wlg0,vec0,n_line,aberr0,1,cawl,cbwl,eawl,ebwl)
       endif
       
       
       
       !------ Spearman coefficient
       call spear0(ewr0,vec0,n_line,spear_ew)
       call spear0(ep0,vec0,n_line,spear_ep)
       call spear0(wlg0,vec0,n_line,spear_wl)
       
       
       !------ check about NaN
       if(caep_t.ne.caep_t)caep_t=9999.
       if(caew_t.ne.caew_t)caew_t=9999.
       if(cawl_t.ne.cawl_t)cawl_t=9999.
       
      endif
      
      
      !--------problems in the fit
      
      if(altnn.ne.0)then
        call alter(star,6)
	call theend(star,temp,gr,met,vmic,alfa)
	return        
      endif
     
     
C-------------------------------------------------------------------  Jackknife bootstrap (Teff & vt)


70    continue
      if(el.eq.qiron.and.n_line.gt.1)then

       do jkk1=1,n_line,1
        do jkk3=1,n_line-1,1
	  if(jkk3.lt.jkk1)then
	    ab_jkk(jkk3)=vec0(jkk3)
	    ep_jkk(jkk3)=ep0(jkk3)
	    aberr_jkk(jkk3)=aberr0(jkk3)
	    ewr_jkk(jkk3)=ewr0(jkk3)
	    ewerr_jkk(jkk3)=ewerr0(jkk3)
	    wl_jkk(jkk3)=wlg0(jkk3)
	   endif 
  	  if(jkk3.ge.jkk1)then
	    ab_jkk(jkk3)=vec0(jkk3+1)
	    ep_jkk(jkk3)=ep0(jkk3+1)
	    aberr_jkk(jkk3)=aberr0(jkk3+1)
	    ewr_jkk(jkk3)=ewr0(jkk3+1)
	    ewerr_jkk(jkk3)=ewerr0(jkk3+1)
	    wl_jkk(jkk3)=wlg0(jkk3+1)
	  endif
        enddo
	
	
	if(errfit.eq.0.or.errmin.eq.0)then

	 call fit_ey(ep_jkk,ab_jkk,n_line-1,aberr_jkk,0,caep_t,cbep_t,
     &                eaep_t,ebep_t)
         call fit_ey(ewr_jkk,ab_jkk,n_line-1,aberr_jkk,0,caew_t,
     &                cbew_t,eaew_t,ebew_t) 
         call fit_ey(wl_jkk,ab_jkk,n_line-1,aberr_jkk,0,cawl_t,
     &                cbwl_t,eawl_t,ebwl_t) 
     
        
	elseif(errfit.eq.1.and.errmin.ne.0)then
	

	 call fit_ey(ep_jkk,ab_jkk,n_line-1,aberr_jkk,1,caep_t,cbep_t,
     &                eaep_t,ebep_t)
         call fit_ey(ewr_jkk,ab_jkk,n_line-1,aberr_jkk,1,caew_t,
     &                cbew_t,eaew_t,ebew_t) 
         call fit_ey(wl_jkk,ab_jkk,n_line-1,aberr_jkk,1,cawl_t,
     &                cbwl_t,eawl_t,ebwl_t) 
	
	
	elseif(errfit.eq.2.and.errmin.ne.0)then
	
         call fit_ey(ep_jkk,ab_jkk,n_line-1,aberr_jkk,1,caep_t,cbep_t,
     &   	     eaep_t,ebep_t)
         call fit_exy(ewr_jkk,ab_jkk,n_line-1,ewerr_jkk,aberr_jkk,
     &   	     caew_t,cbew_t,eaew_t,ebew_t) 
         call fit_ey(wl_jkk,ab_jkk,n_line-1,aberr_jkk,1,cawl_t,
     &                cbwl_t,eawl_t,ebwl_t) 
	
	endif
	
	
	
	!------ check about NaN
	if(caep_t.ne.caep_t)caep_t=9999
	if(caew_t.ne.caew_t)caew_t=9999
	if(cawl_t.ne.cawl_t)cawl_t=9999
	
    	jack_ep(jkk1)=caep_t
	jack_ew(jkk1)=caew_t
	jack_wl(jkk1)=cawl_t
       enddo
        
	
        call calsig(jack_ep,n_line,mean_jkk,sig_jkk)
        jack_teff=sig_jkk*((n_line-1)**0.5)
        call calsig(jack_ew,n_line,mean_jkk,sig_jkk)
        jack_vt=sig_jkk*((n_line-1)**0.5)	
        call calsig(jack_wl,n_line,mean_jkk,sig_jkk)
        jack_wave=sig_jkk*((n_line-1)**0.5)
	
      endif
      

C-------------------------------------------------------------------  Jackknife bootstrap (logg)


      if(dim2.le.1)jack_logg=0.0
      if(dim.le.1)jack_logg=0.0
      
      if(dim2.gt.1.and.dim.gt.1)then
      
       jk1=1
       jk2=1      
       njkk1=1
       njkk2=1
       
       do ie=1,num_lin
	if(matrix(ie,11).eq.1)then
	
	 if(matrix(ie,5).eq.qiron.or.matrix(ie,5).eq.qiron2)then
	   jack_grav1(jk1)=matrix(ie,6)
	   jack_grav2(jk1)=matrix(ie,7) 
	   jack_grav3(jk1)=matrix(ie,5)
	   jk1=jk1+1  
	 endif 
	  
	  if(matrix(ie,5).eq.qiron)njkk1=njkk1+1
	  if(matrix(ie,5).eq.qiron2)njkk2=njkk2+1
	endif
       enddo
       
       njkk1=njkk1-1
       njkk2=njkk2-1	
       jk1=jk1-1
        	
       do jkk1=1,jk1,1
       
        do jkk3=1,jk1-1,1
	    
	   ! vector with all the neutral/single-ionized lines - 1
	   if(jkk3.lt.jkk1)then
	    abg_jkk1(jkk3)=jack_grav1(jkk3)
	    erg_jkk1(jkk3)=jack_grav2(jkk3)
	    elg_jkk1(jkk3)=jack_grav3(jkk3)
	   endif 
	   if(jkk3.ge.jkk1)then
	    abg_jkk1(jkk3)=jack_grav1(jkk3+1)
	    erg_jkk1(jkk3)=jack_grav2(jkk3+1)
	    elg_jkk1(jkk3)=jack_grav3(jkk3+1)
	   endif 
	    	  
         enddo
	 
	 ij=1
	 ik=1
	 do i=1,jk1-1
	  if(elg_jkk1(i).eq.qiron)then
	    abg_jkk_fe1(ij)=abg_jkk1(i)
	    erg_jkk_fe1(ij)=erg_jkk1(i)
	    ij=ij+1
	  else
	    abg_jkk_fe2(ik)=abg_jkk1(i)
	    erg_jkk_fe2(ik)=erg_jkk1(i)	  
	    ik=ik+1
	  endif 
	 enddo
	
	if(xer0.eq.0.)then
	 call calsig(abg_jkk_fe1,ij-1,mean_jk1,sig_jk1)
	 call calsig(abg_jkk_fe2,ik-1,mean_jk2,sig_jk2)
	else
	 call calsigw(abg_jkk_fe1,ij-1,erg_jkk_fe1,mean_jk1,sig_jk1)
	 call calsigw(abg_jkk_fe2,ik-1,erg_jkk_fe2,mean_jk2,sig_jk2)
	endif 
	jack_dif(jkk1)=mean_jk1-mean_jk2
       enddo
       
       call calsig(jack_dif,jk1,mean_jkk,sig_jkk)
       jack_logg=sig_jkk*((jk1-1)**0.5)
             
      endif
      
      
      
C-------------------------------------------------------------------
      

69    continue
     
      if(el.eq.qiron)then
        dim=n_line
	mean=n_mean
	sigf=n_sigf
      endif
      
      if(el.eq.qiron2)then
        dim2=n_line
	mean2=n_mean
	sigf2=n_sigf
      endif


C-------------------------------------------------------------------  FORMATS


603   format(F11.3,4X,F7.2,4X,F8.3,4X,F7.3,4X,F8.3,2X,F10.2,3X,
     &      F6.2,2X,F5.2,3X,F6.0,3X,F7.2,8(4X,F8.3))
      
      end subroutine


