CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC




      subroutine loopvt(v,t,met,g,star,alfa,par_v0,count0,nn,m0)



C----------------------------------------------------------------------

      implicit none
      include 'Declare.f'           
      
      
      pday=3
      
      xx=0
      j=1
      b=0
      
      do k=1,100
        bunker_vt(k,1)=0.
	bunker_vt(k,2)=0.
      enddo
      
      if(vtc.eq.0)then
        if(verbose.ge.2)write(*,*)'MICROTURBULENT VELOCITY FIXED!!!'
        call iron1(star,2,26.01)

        difg=(m0-mean2)
        nn=1
        call loopg(v,t,met,g,star,alfa,difg,count0,nn)
	return
	
      endif
 
       
      if(verbose.ge.2)write(*,*)'----------- CALL VTURB LOOP'  
      
      glam=1
      vt_or=v 
      par_vinit=par_v0
      
      if(par_v0.gt.0)stepvt=abs(stepvt)
      if(par_v0.lt.0)stepvt=-abs(stepvt)
      
      if(verbose.eq.3)then
       write(*,*)'Teff   logg    vt    [M/H]     slope    Jackknife
     &    Merit'            
       write(*,410)t,g,vt_or,met,par_v0,jack_vt,merit
      endif
      
      bunker_vt(1,1)=vt_or
      bunker_vt(1,2)=par_v0
            
C----------------------------------------------------------------------
      

901   continue
      
      v_new=v+stepvt   
      v_new=int(v_new)+(nint(100.*(v_new-int(v_new))))/100.
      if(v_new.lt.0.or.v_new.gt.4)then
        !c_avt=0.
        goto 100
      endif
      
      
       
ccc   compute the Fe~I abundance with vt = vt(main) + delta_vt

      
      call xabu(star,t,g,met,v_new,alfa,2)     
	t=txxx
	g=grxxx      
      
      if(verbose.eq.3)write(*,410)t,g,v_new,met,par_v,jack_vt,merit
      
    !-----
      
      j=j+1      
      bunker_vt(j,1)=v_new
      bunker_vt(j,2)=par_v
      
      
      if(j.eq.2)then
        if(bunker_vt(j,2).gt.bunker_vt(j-1,2))b0=1
	if(bunker_vt(j,2).lt.bunker_vt(j-1,2))b0=-1
	b=b0
      endif
      
      
      if(j.gt.2)then
        b0=b
        if(bunker_vt(j,2).gt.bunker_vt(j-1,2))b=1
	if(bunker_vt(j,2).lt.bunker_vt(j-1,2))b=-1        
      endif
      
      
      if(j.gt.2.and.b.ne.b0)then
        v=bunker_vt(j-1,1)
	if(verbose.ge.2)write(*,*)'END  VTURB LOOP'
	!stop
	goto 100
      endif    
    
    !-----
              
      
      if(par_v0.gt.0.and.par_v.gt.0)then
        nn=nn+1
        v=v_new
	par_v0=par_v
        goto 901
      elseif(par_v0.lt.0.and.par_v.lt.0)then
        nn=nn+1
        v=v_new
	par_v0=par_v
        goto 901
      elseif(par_v0.gt.0.and.par_v.lt.0)then
        par_vmin=min(abs(par_v0),abs(par_v))
	if(par_vmin.eq.abs(par_v0))v=v
	if(par_vmin.eq.abs(par_v))v=v_new
      elseif(par_v0.lt.0.and.par_v.gt.0)then
        par_vmin=min(abs(par_v0),abs(par_v))
	if(par_vmin.eq.abs(par_v0))v=v
	if(par_vmin.eq.abs(par_v))v=v_new
      endif
      
      
C----------------------------------------------------------------------
      
100   continue      
      
      
      call xabu(star,t,g,met,v,alfa,2)     
	t=txxx
	g=grxxx
      difg=(mean-mean2)
      
      if(verbose.ge.2)write(*,*)'----------- END  VTURB LOOP'
      
      if(paropt.eq.0)par_v=caew     
      if(paropt.eq.1)par_v=spear_ew
         
      if(par_v.eq.par_v0)then
          store_slope(2)=par_v0
	  nn=1
          call loopg(v,t,met,g,star,alfa,difg,count0,nn)
	  return
      else

          call repeat(t,g,met,v,alfa,ll,count0)

	  if(ll.eq.-1)call main(star,t,g,met,v,alfa,count0)
	  if(ll.eq.0.and.(abs(difg/jack_logg)).gt.1)then
     	     nn=1
     	     call loopg(v,t,met,g,star,alfa,difg,count0,nn)
	     return
	  endif   
          if(ll.eq.0.and.(abs(difg/jack_logg)).le.1)then
	     xx=xx+1
	     if(verbose.ge.2)write(*,*)'REPEATED MODEL!!!'
             call theend(star,t,g,met,v,alfa)
	     return
	  endif   
     
      endif	
      
    
C-------------------------------------------------------------------  FORMATS

 
403   format(F5.2,2X,F7.4,2X,F5.2,2X,F7.4)
410   format(I5,3X,F4.2,3X,F4.2,3X,F5.2,3X,F7.3,4X,F7.3,3X,F8.2)  


      end subroutine
 

