CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine main(star,temp,gr,met,vmic,alfa,count0)

C-----------------------------------------------------------------------  MAIN SUBROUTINE

      implicit none
      include 'Declare.f' 
      include 'Marcs.f' 
      
      
      glam=0
      iexit=0
800   continue     
   
   
      count0=count0+1
      pday=0
      
      
      !----alternative model
      if(ym.eq.0)goto 505
            
      
      
      !----if the number of total lines is larger than the 'matrix' dimension INL
      if(num_lin.gt.INL)then
        call alter(star,8)
        return
      endif	
      
      !----check for NaN in the atmospherical parameters
      if((temp.ne.temp).or.(gr.ne.gr).or.
     &   (met.ne.met).or.(vmic.ne.vmic))then
         if(verbose.ge.2)write(*,*)'EXIT FOR NaN'
         call alter(star,9)
	 return
      endif
      
      
      if(verbose.ge.2)then
      
      if(count0.eq.1.and.guess2.eq.1.and.count2.eq.0)
     &      write(*,*)'-----------------------------------------------
     &------ANALYSIS WORKING BLOCK'
     
     
      write(*,*) 'ITERATION', count0 
      
      
      endif
      
      if(verbose.eq.3)then
       
      write(*,*)'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%'
      write(*,*)'%						      
     &        %'
      write(*,305)'% Teff=',temp,'logg=',gr,'vt=',vmic,'[M/H]=',met,
     &' alfa=',alfa,'%'
      write(*,*)'%						      
     &        %'
      write(*,*)'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%'
     
      endif
  
C-----------------------------------------------------------------------  
      if(count0.gt.1)then
       call repeat(temp,gr,met,vmic,alfa,ll,count0)
       if(ll.eq.0)then
	if(verbose.eq.3)write(*,*)'REPEATED MODEL!!!'
	call theend(star,temp,gr,met,vmic,alfa) 
	return
       endif
      endif 
  
  
C----------------------------------------------------------------------- check the atmospherical parameters    
      
      !---- boundary for ATLAS9 models (teff=3500-20000 K)
      if(ym.eq.2)then      

101     continue      

        if(temp.lt.3500)temp=3500
        if(temp.gt.20000)temp=20000	   
        if(gr.lt.0)gr=0.0
        if(gr.gt.5.0)gr=5.0	
        call Atlas9(star,temp,gr,met,vmic,alfa)
        
       
        
	dmin=1e5
	do i=1,dim_grid(1)
	  dmin=min(dmin,abs(met-mj(i,1)))
	  if(dmin.eq.abs(met-mj(i,1)))metx=mj(i,1)
	enddo
        
	dmin=1e5
	do i=1,dim_grid(1)
	  if(mj(i,1).eq.metx)then
	   do j=2,dim_grid(2)+1
	    dmin=min(dmin,abs(alfa-mj(i,j)))
	    if(dmin.eq.abs(alfa-mj(i,j)))alfx=mj(i,j)
	   enddo 
	  endif
	enddo
      
     	if(metx.ne.met)then
     	   write(*,'(A32,F5.2)')'CHANGE MODEL METALLICITY, [M/H]=',metx
     	   met=metx
	   iexit=0
	   goto 101
     	endif	   
     	if(alfx.ne.alfa)then
     	   write(*,'(A33,F5.2)')'CHANGE MODEL alfa-enh, [alfa/Fe]=',alfx 
     	   alfa=alfx
	   iexit=0
	   goto 101
     	endif
	
	
     	if(iexit.eq.3)then
    	  call alter(star,11)
    	  return
     	endif
       
     	if(iexit.eq.4)then
    	  call alter(star,12)
    	  return
     	endif
     	 
      
      endif
     
      !---- boundary for MARCS models      
      if(ym.eq.1)then
       if(temp.lt.2500)temp=2500    
       if(temp.gt.8000)temp=8000        
       if(gr.lt.-0.5)gr=-0.5
       if(gr.gt.5.5)gr=5.5     
       
 
       dmin=1e15
       do i=1,15
         dmin=min(dmin,abs(met-mj_marcs(i)))
         if(dmin.eq.abs(met-mj_marcs(i)))
     &      metx=mj_marcs(i)
       enddo	  
  
       if(metx.ne.met)then
         write(*,'(A32,F5.2)')'CHANGE MODEL METALLICITY, [M/H]=',metx
	 met=metx
       endif	 
       
      
       if(met.ge.0.)alfa=0.0
       if(met.eq.-0.25)alfa=+0.10
       if(met.eq.-0.50)alfa=+0.20
       if(met.eq.-0.75)alfa=+0.30
       if(met.le.-1.)alfa=0.0
       
      endif
      
      
      !---- only positive microturbulent velocities and less than 8 km/s
      if(vmic.lt.0)vmic=0
      if(vmic.gt.8)vmic=8
      
       
C-----------------------------------------------------------------------  check the iterations number

      if(count0.eq.iter)then
       call alter(star,1)	
       return
      endif
      
      
C-----------------------------------------------------------------------  FIRST RUN   
505   continue      
      if(count0.eq.1)then
         
	 !---initialize vectors and matrix
         
         dim=0
         dim2=0
         dim3=0
         fe1=0
         fe2=0  
	 
         do i=1,INL
            mod_dmp(i,1)=0.
     	    mod_dmp(i,2)=0.
     	    mod_dmp(i,3)=0.
     	    mod_dmp(i,4)=0.
     	    mod_dmp(i,5)=0.
         enddo
         
         do i=1,INL	
     	   verguenza(i)=0.
         enddo 
          
         do i=1,INL
          do j=1,21
           matrix(i,j)=0.
          enddo
         enddo 
 
 
 	 !---first call of width9_gala 
	 call xabu(star,temp,gr,met,vmic,alfa,-1)
	 
	 temp=txxx
	 gr=grxxx
	 if(iexit.ne.0)goto 999
	 
	 
	 
	 !---call 'iron1' for the first time (line-rejection)        
	 call iron1(star,1,qiron)
	 call iron1(star,1,qiron2)
	 

   	 if(paropt.eq.0)par_t=caep	
   	 if(paropt.eq.1)par_t=spear_ep

   	 if(paropt.eq.0)par_v=caew	
   	 if(paropt.eq.1)par_v=spear_ew
   	 
	 
	 !----calculate the merit function for the first run
         call xmerit
	 
	 
	 !--- too few Fe lines...optimization swichted off
	 if(epot.eq.1.or.grc.ne.0.or.vtc.eq.1)then
	  if(dim.lt.minnfe)then
           if(verbose.ge.2)
     &        write(*,*)'TOO FEW LINES: OPTIMIZATION SWICHTED OFF'
	   grc=0
	   epot=0
	   vtc=0 
	   call theend(star,temp,gr,met,vmic,alfa)
	   return
	  endif
	 endif 
	  
	  
	!--- too small E.P. range ... Teff optimization swichted off
	if(epot.eq.1.and.difep.le.eplever)then
          if(verbose.ge.2)
     &       write(*,*)'E.P. RANGE TOO SMALL: OPTIMIZATION SWICHTED OFF'
	  epot=0
	endif
	  
      endif
        
	!--- store the atm. parameters in 'mod_dmp'
        mod_dmp(count0,1)=temp
        mod_dmp(count0,2)=gr
        mod_dmp(count0,3)=met
        mod_dmp(count0,4)=vmic
        mod_dmp(count0,5)=alfa

C----------------------------------------------------------------------- call Guess Working-Block
 
      
      if(guess.ge.1.and.guess2.eq.0)then
       call guesspar(star,temp,gr,met,vmic,alfa)
       return
      endif	
      


C-----------------------------------------------------------------------  following iterations
     
      if(count0.gt.1)then
	 
	 !--- initialize the abundances (and their errors) in matrix 
         do i=1,INL
          matrix(i,6)=0.
          matrix(i,7)=0.
         enddo
	
	 !--- call width9_gala
	 call xabu(star,temp,gr,met,vmic,alfa,2)
	 temp=txxx
	 gr=grxxx
	 if(iexit.ne.0)goto 999
	 
      endif        

      !----check for NaN in the abundances
      if((mean.ne.mean).or.(mean2.ne.mean2))then
        write(*,*)mean,mean2
         write(*,*)'EXIT FOR NaN'
         call alter(star,9)
	 return
      endif
      
      
      !----summary 
       if(qiron.eq.nint(qiron))then
        dance1=' I ABUNDANCE'
        dance2=' II ABUNDANCE'
       else
        dance1=' II ABUNDANCE'
        dance2=' I ABUNDANCE'      
       endif	
       
      if(verbose.eq.3)then
       if(dim.ne.0)write(*,306)dim,mean,sigf,xelem,dance1
       if(dim2.ne.0)write(*,306)dim2,mean2,sigf2,xelem,dance2
      endif
      
      !----too large lines dispersion
      if(sigf.ge.maxsig)then
         call alter(star,7)    
	 grc=0
	 epot=0
	 vtc=0
	 call iron1(star,1,real(nint(qiron)))  
	 call iron1(star,1,max(qiron,qiron2))  
	 call theend(star,temp,gr,met,vmic,alfa)
         return
      endif             
     
C------------------------------------------------------------------- check metallicity

      if(metal.eq.1)then
       call loopmet(modnew)  
       if(met.ne.modnew)then
        glam=0
        met=modnew
        if(verbose.eq.3)write(*,*)'CHANGE [M/H]'
	call repeat(temp,gr,met,vmic,alfa,ll,count0)
        if(met.ne.minput.and.ll.eq.-1)goto 800
       endif        
      endif
      
      
     
            
      num=1   
                        
500   continue
      
      
C----------------------------------------------------------------------- choice of the optimization method


      if(paropt.eq.0)then
       par_t0=caep
       par_v0=caew
      endif
      
      if(paropt.eq.1)then
       par_t0=spear_ep
       par_v0=spear_ew
      endif
      
      
C----------------------------------------------------------------------- optimization 
      

      if(epot.eq.1)then  
           call loopt(vmic,temp,met,gr,star,alfa,par_t0,count0,num)
      elseif(epot.eq.0.and.vtc.gt.0)then
           if(verbose.ge.2)write(*,*)'TEMPERATURE FIXED!!!'
	   call loopvt(vmic,temp,met,gr,star,alfa,par_v0,count0,num,mean)	
      elseif(epot.eq.0.and.grc.gt.0)then
           if(verbose.ge.2)write(*,*)'TEMPERATURE FIXED!!!'
	   call loopvt(vmic,temp,met,gr,star,alfa,par_v0,count0,num,mean)	
      elseif(epot.eq.0.and.vtc.eq.0.and.grc.eq.0)then
           call theend(star,temp,gr,met,vmic,alfa) 
	   return
      endif	
      
      
C-------------------------------------------------------------------  FORMATS

     
305   format(A8,1X,I5,2X,A5,1X,F5.2,2X,A3,F4.2,2X,A6,F5.2,1X,
     &       A6,F5.2,1X,A1)
306   format(I3,2x,F5.2,2x,F4.2,6X,A2,A13)


999   continue      
      end subroutine
 
 
 
    
       
 
