CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      subroutine reje1(star,ig,el)

C***************************************************************************** rejection of (qiron) lines

     
      implicit none
      include 'Declare.f'

      altnn=0
      
      c1=0.
      c2=0.
      c3=0.
      c4=0.
      
      
      
      !line-rejection switched off if ...
      
      ! rj!=0 and rj!=1
      if(rj.ne.0.and.rj.ne.1.)goto 700
      
      ! too few lines of 'qiron'
      if(el.eq.qiron.and.nfe1.le.minl)goto 700
      
      ! too few lines of 'qiron2'
      if(el.eq.qiron2.and.nfe2.le.minl)goto 700
      
      ! only line-rejection based on the abundance
      ! distribution for 'qiron2'
      if(el.eq.qiron2.and.nfe2.gt.minl)goto 710
      
      
      
C------------------------------------------------------------------   rejection 1 (EWR vs ABU)
      
      errmin=1000.
      if(vtc.eq.1.and.qiron.eq.el)then  
       it=1
       
       do ie=1,num_lin
	
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1)then
	 ewr1(it)=matrix(ie,10)
	 ab1(it)=matrix(ie,6)
	 aberr1(it)=matrix(ie,7)  
	 eup(it)=log10((matrix(ie,2)+matrix(ie,8))/matrix(ie,1))-3  
	 elo(it)=log10((matrix(ie,2)-matrix(ie,8))/matrix(ie,1))-3 
         ewrr1(it)=(abs(ewr1(it)-eup(it))+abs(ewr1(it)-elo(it)))/2
	 errmin=min(ewrr1(it),errmin)
	 it=it+1
	endif
       enddo
       
       id=it-1    !  number of good lines
      
       
       
       if(errfit.eq.0.or.errmin.eq.0)
     &    call fit_ey(ewr1,ab1,id,aberr1,0,c1,c2,c3,c4)   
       if(errfit.eq.1.and.errmin.ne.0)
     &    call fit_ey(ewr1,ab1,id,aberr1,1,c1,c2,c3,c4)   
       if(errfit.eq.2.and.errmin.ne.0)
     &    call fit_exy(ewr1,ab1,id,ewrr1,aberr1,c1,c2,c3,c4)
     
       
       
         
      if(altnn.ne.0)then
        write(*,*)'bug in reje1'
        call alter(star,6)
	call theend(star,temp,gr,met,vmic,alfa)
	return        
      endif
  
                
       ih=1       
       do ij=1,num_lin
	if(matrix(ij,5).eq.el.and.matrix(ij,11).eq.1)then
	 dist(ij)=(matrix(ij,6)-c1*matrix(ij,10)-c2)/(sqrt(1+c1*c1))
	 dist2(ih)=dist(ij)
	 ih=ih+1
       else
	 dist(ij)=99999 
       endif 
      enddo 

       if(rj.eq.0)call calsig(dist2,id,m,s)
       if(rj.eq.1)call calsig2(dist2,id,m,s)
       thr=m+smax*s
       thr0=m-smax*s
 
               
       
       
       do ie=1,num_lin,1
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1.and.
     &     dist(ie).gt.thr)matrix(ie,11)=0
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1.and.
     &     dist(ie).lt.thr0)matrix(ie,11)=0 	
       enddo      
                 
		 
      endif      
  
C-----------------------------------------------------------------   rejection 2 (EP vs ABU)

  
      if(epot.eq.1.and.qiron.eq.el)then 
      
       it=1
       do ie=1,num_lin
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1)then
	 ep1(it)=matrix(ie,4)
	 ab1(it)=matrix(ie,6)
	 aberr1(it)=matrix(ie,7)
	 it=it+1
	endif
       enddo
            
       id=it-1    ! number of good lines
       
       
       if(errfit.eq.0.or.errmin.eq.0)then
          call fit_ey(ep1,ab1,id,aberr1,0,c1,c2,c3,c4)  
       else
          call fit_ey(ep1,ab1,id,aberr1,1,c1,c2,c3,c4)       
       endif
       
       
      
       ih=1
       do ij=1,num_lin,1    
        if(matrix(ij,5).eq.el.and.matrix(ij,11).eq.1)then
	 dist(ij)=(matrix(ij,6)-c1*matrix(ij,4)-c2)/(sqrt(1+c1*c1))
	 dist2(ih)=dist(ij)
	 ih=ih+1
	else
	 dist(ij)=99999 
	endif 
       enddo 
       
       id=ih-1   
       if(rj.eq.0)call calsig(dist2,id,m,s)
       if(rj.eq.1)call calsig2(dist2,id,m,s)
       
       thr=m+smax*s
       thr0=m-smax*s
       
       do ie=1,num_lin,1
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1.and.
     &     dist(ie).gt.thr)matrix(ie,11)=0
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1.and.
     &     dist(ie).lt.thr0)matrix(ie,11)=0
 	
       enddo      
      
      endif
         

      
C-------------------------------------------------------------------  rejection 3 (ABU)
710   continue

      ijj=1
      ix=1
      
      it=1
      
      if((qiron.eq.el.and.epot.eq.0.and.vtc.eq.0).or.(qiron.ne.el))then
      
       do ie=1,num_lin
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1)then
	 ab1(it)=matrix(ie,6)
	 it=it+1
	endif
       enddo       
       it=it-1
        
	!------- mean
        if(rj.eq.0)then
	  call calsig(ab1,it,m,s)
          thr0=m-smax*s
	  thr1=m+smax*s
	  
           do ie=1,num_lin
            if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1.and.
     &      matrix(ie,6).lt.thr0)matrix(ie,11)=0
            if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1.and.
     &      matrix(ie,6).gt.thr1)matrix(ie,11)=0
           enddo  
	    
	endif
	
	!------- median
        if(rj.eq.1)then
	  call calsig2(ab1,it,m,s)
          thr0=m-smax*s
	  thr1=m+smax*s
	  
           do ie=1,num_lin
            if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1.and.
     &      matrix(ie,6).lt.thr0)matrix(ie,11)=0
            if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1.and.
     &      matrix(ie,6).gt.thr1)matrix(ie,11)=0
           enddo  
	        	
	endif
      
      
      
      endif
      
C------------------------------------------------------------------ summary

700   continue
      
      it=0
      ir=0
      ig=0
      il=0
      id=0
      im=0            
      do ie=1,num_lin,1
        if(matrix(ie,5).eq.el)it=it+1
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.1)ig=ig+1
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.0)ir=ir+1
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.-1)il=il+1
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.-2)id=id+1
        if(matrix(ie,5).eq.el.and.matrix(ie,11).eq.-3)im=im+1
      enddo      
      
      
      if(verbose.eq.3)then
      
      if(el.eq.nint(qiron))
     &write(*,603)'##################### LINE REJECTION', 
     &xelem,' I '
      if(el.eq.max(qiron,qiron2))
     &write(*,603)'##################### LINE REJECTION', 
     &xelem,' II'
     
      write(*,*)'NUMBER OF LINES                       ', it     
      write(*,*)'NUMBER OF REJECTED LINES (EW LIMITS)  ', il         ! -1
      write(*,*)'NUMBER OF REJECTED LINES (SIGMA-CLIP) ', ir         !  0
      write(*,*)'NUMBER OF REJECTED LINES (EW ERROR)   ', id         ! -2
      write(*,*)'NUMBER OF NaN LINES                   ', im         ! -3
      write(*,*)'NUMBER OF SURVIVING LINES             ', ig         !  1
     
      endif
      
602   format(F8.3,3X,F4.0,3X,F5.3)
603   format(A36,2x,A2,A3)
      
      end subroutine
  

 
