CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine runm(star,t,gr,fe,vt,nn)
    
    
      implicit none
    
     
    
      include 'Declare.f'
      include 'Marcs.f'
      include 'Paths.f'  
      
      gr=int(gr)+0.1*(nint(10*(gr-int(gr))))
      
      
C------ initialize some matrix...
      
      do i=1,33
       do j=1,9
        marcs_tmp(i,j)=0.
       enddo
      enddo

C------- geometry flag
      
      if(gr.le.3.2)geometry=0  
      if(gr.gt.3.2)geometry=1    
      
      teff=real(t)
       
      if(gr.le.3.2.and.gr.lt.-0.5)gr=-0.5 
      if(gr.gt.3.2.and.gr.gt.5.5)gr=5.5 
       
       
      inp=star(1:len_trim(star))//'.in'
     

      !----at the first run
      
      if(nn.eq.1)then
        open(unit=3,file=inp,status='unknown')  
783     read(3,'(A)',end=784)linec
        linei=index(linec,'*')
	if(linei.ne.0)then
         write(*,*)'EXIT FOR ***** IN WIDTH INPUT FILES'
	 iexit=5
	 goto 500	
	endif
	goto 783
784     continue
        close(3)	
      endif
           
     
      !----
     
     
      if(nn.eq.1)then
       xer0=0
       open(unit=3,file=inp,status='unknown')   
       ie=1 
785    read(3,*,end=786)x,x,xer(ie)
       xer0=xer0+xer(ie)
       ie=ie+1
       goto 785
786    continue       
       close(3)
      endif
             

C--------------------------------------------------------- gravities
      
      do i=1,13,1
        igg=0.5*i-1
        dfgm=igg-gr
	if(abs(dfgm).lt.1e-4)then
	  logg_n1=gr
	  logg_n2=gr
	  goto 200
	endif
      enddo
      
      
      yy1=10000.
      yy2=10000.
      
      !---------------------- MARCS spherical models 
      if(gr.le.3.2.and.gr.ge.-0.5)then

       do i=1,9,1
        igg=grav_sp(i) 
        dfgm=igg-gr
	if(dfgm.le.0.and.abs(dfgm).lt.abs(yy1))then
	  logg_n1 = igg
	  yy1 = dfgm	  
	endif
	if(dfgm.ge.0.and.abs(dfgm).lt.abs(yy2))then
	  logg_n2 = igg
	  yy2 = dfgm	  
	endif	
       enddo
      elseif(gr.lt.-0.5)then
         logg_n1 = -0.5
	 logg_n2 = -0.5
	 
      elseif(gr.gt.3.2.and.gr.le.5.5)then


      !---------------------- MARCS plane-parallel models 

       do i=1,6,1
        igg=grav_pp(i)
        dfgm=igg-gr
	if(dfgm.le.0.and.abs(dfgm).lt.abs(yy1))then
	  logg_n1 = igg
	  yy1 = dfgm	  
	endif
	if(dfgm.ge.0.and.abs(dfgm).lt.abs(yy2))then
	  logg_n2 = igg
	  yy2 = dfgm	  
	endif	
       enddo
       
      elseif(gr.gt.5.5)then
        logg_n1 = 5.5
	logg_n2 = 5.5        
      endif
      
      
C--------------------------------------------------------- temperatures

200   continue
     
      if(gr.gt.3.2)then
       do i=1,6
        do j=1,33
          if(fe.eq.1.00)marcs_tmp(j,i)=ppp100(j,i)
          if(fe.eq.0.75)marcs_tmp(j,i)=ppp075(j,i)
          if(fe.eq.0.50)marcs_tmp(j,i)=ppp050(j,i)
          if(fe.eq.0.25)marcs_tmp(j,i)=ppp025(j,i)
          if(fe.eq.0.00)marcs_tmp(j,i)=ppp000(j,i)
          if(fe.eq.-0.25)marcs_tmp(j,i)=ppm025(j,i)
          if(fe.eq.-0.50)marcs_tmp(j,i)=ppm050(j,i)
          if(fe.eq.-0.75)marcs_tmp(j,i)=ppm075(j,i)
          if(fe.eq.-1.00)marcs_tmp(j,i)=ppm100(j,i)
          if(fe.eq.-1.50)marcs_tmp(j,i)=ppm150(j,i)
          if(fe.eq.-2.00)marcs_tmp(j,i)=ppm200(j,i)
          if(fe.eq.-2.50)marcs_tmp(j,i)=ppm250(j,i)
          if(fe.eq.-3.00)marcs_tmp(j,i)=ppm300(j,i)
          if(fe.eq.-4.00)marcs_tmp(j,i)=ppm400(j,i)
          if(fe.eq.-5.00)marcs_tmp(j,i)=ppm500(j,i)
        enddo
       enddo 
      else
       do i=1,9
        do j=1,33
          if(fe.eq.1.00)marcs_tmp(j,i)=sphp100(j,i)
          if(fe.eq.0.75)marcs_tmp(j,i)=sphp075(j,i)
          if(fe.eq.0.50)marcs_tmp(j,i)=sphp050(j,i)
          if(fe.eq.0.25)marcs_tmp(j,i)=sphp025(j,i)
          if(fe.eq.0.00)marcs_tmp(j,i)=sphp000(j,i)
          if(fe.eq.-0.25)marcs_tmp(j,i)=sphm025(j,i)
          if(fe.eq.-0.50)marcs_tmp(j,i)=sphm050(j,i)
          if(fe.eq.-0.75)marcs_tmp(j,i)=sphm075(j,i)
          if(fe.eq.-1.00)marcs_tmp(j,i)=sphm100(j,i)
          if(fe.eq.-1.50)marcs_tmp(j,i)=sphm150(j,i)
          if(fe.eq.-2.00)marcs_tmp(j,i)=sphm200(j,i)
          if(fe.eq.-2.50)marcs_tmp(j,i)=sphm250(j,i)
          if(fe.eq.-3.00)marcs_tmp(j,i)=sphm300(j,i)
          if(fe.eq.-4.00)marcs_tmp(j,i)=sphm400(j,i)
          if(fe.eq.-5.00)marcs_tmp(j,i)=sphm500(j,i)		        	
        enddo
       enddo 
      endif  
     
      
      
      if(gr.gt.3.2)then
      
       do i=1,6
        if(marcs_tmp(33,i).eq.logg_n1)then
         do j=1,33
          tgrid_n1(j)=marcs_tmp(j,i)
	 enddo 
        endif	
     
        if(marcs_tmp(33,i).eq.logg_n2)then
         do j=1,33
          tgrid_n2(j)=marcs_tmp(j,i)
	 enddo 
        endif               
       enddo 
       
      endif
    
       
       
      if(gr.le.3.2)then    
         
       do ii=1,9
        if(marcs_tmp(33,ii).eq.logg_n1)then
         do j=1,33
          tgrid_n1(j)=marcs_tmp(j,ii)
	 enddo 
        endif	
     
        if(marcs_tmp(33,ii).eq.logg_n2)then
         do j=1,33
          tgrid_n2(j)=marcs_tmp(j,ii)
	 enddo 
        endif               
       enddo 
       
      endif
       
       
       min_t_n1=1e6
       max_t_n1=0.
       do j=1,32
        if(tgrid_n1(j).ne.0.and.tgrid_n1(j).lt.min_t_n1)
     &    min_t_n1=tgrid_n1(j)
        if(tgrid_n1(j).ne.0.and.tgrid_n1(j).gt.max_t_n1)
     &    max_t_n1=tgrid_n1(j)	 
       enddo
       
      
!---- T1     
       dt0=-1e6
       dp0=1e6
       do j=1,32
         dt1=tgrid_n1(j)-teff
	 if(dt1.le.0)then
	  if(dt1.gt.dt0.and.tgrid_n1(j).ne.0)then
	   dt0=dt1
	   tbest1=tgrid_n1(j)
	  endif
	 else
	  if(dt1.le.dp0.and.tgrid_n1(j).ne.0)then
	   dp0=dt1
	   tbest2=tgrid_n1(j)
	  endif	  
	 endif 
       enddo
     
      
     
!---- T2   
       dt0=-1e6
       dp0=1e6
       do j=1,32
         dt1=tgrid_n2(j)-teff
	 if(dt1.le.0)then
	  if(dt1.gt.dt0.and.tgrid_n2(j).ne.0)then
	   dt0=dt1
	   tbest3=tgrid_n2(j)
	  endif
	 else
	  if(dt1.le.dp0.and.tgrid_n2(j).ne.0)then
	   dp0=dt1
	   tbest4=tgrid_n2(j)
	  endif	  
	 endif 
       enddo
      
      
 
C------------------------------------------------------  at least one of the corners is 0.0   
 
       

      
C    g1     T1 ---- T2
C            |      |
C            |	    |
C    g2     T3 ---- T4


C------------------------------------------------------


!---- possible cases:

!---- (1) g1!=g2 T1=T3 T2=F4 regular square OK!

!---- (2) g1!=g2 if(T1=T3) but (T2!=T4) or (T2=T4) but (T1!=T3)      
!         

!      teff_n1 teff_n2

C------------------------------------------------------
       
       !----- good square!
       
       !      X --- X        
       !      |     |
       !      |     |
       !      X --- X
       !       
       
       txxx=t
       grxxx=gr
       
       if(tbest1.eq.tbest3.and.tbest2.eq.tbest4)then
         teff_n1=tbest1
	 teff_n2=tbest2
       endif	 
       
       !----- It is not a square! 
       
       !      X --- X                 X --- O --- X
       !      |        \	      |        /
       !      |         \	      |       /
       !      X --- O --- X	      X --- X
       !
       
       !----- T1=T2 but T2!=T4
       if(tbest1.eq.tbest3.and.tbest2.gt.tbest4)then
         teff_n1=tbest1
	 teff_n2=tbest1
	 t=tbest1
         do j=1,32
	   if(tgrid_n2(j).eq.tbest2)teff_n2=tgrid_n2(j)
	 enddo
       elseif(tbest1.eq.tbest3.and.tbest4.gt.tbest2)then
         teff_n1=tbest1
	 teff_n2=tbest1
	 t=tbest1
         do j=1,32
	   if(tgrid_n1(j).eq.tbest4)teff_n2=tgrid_n1(j)
	 enddo
       endif	
        
       !          X --- X         X --- O --- X     
       !       /        | 	    \         | 
       !      /         |	     \	      |
       !    X --- O --- X	        X --- X
       !
  	
	
       !----- T2=T4 but T1!=T3
       if(tbest2.eq.tbest4.and.tbest3.gt.tbest1)then
         teff_n1=tbest4
         teff_n2=tbest4
	 t=tbest4
         do j=1,32
	   if(tgrid_n1(j).eq.tbest3)teff_n1=tgrid_n1(j)
	 enddo
       elseif(tbest2.eq.tbest4.and.tbest1.gt.tbest3)then
         teff_n1=tbest4
         teff_n2=tbest4
	 t=tbest4
         do j=1,32
	   if(tgrid_n2(j).eq.tbest2)teff_n1=tgrid_n2(j)
	 enddo       
       endif


       !---- T2!=T4 and T1!=T3
       
        
       !          X --- X          
       !       /          \ 	  
       !      /            \	   
       !    X ------ O ----- X	   
       !
       
      if((tbest1.ne.tbest3.and.tbest2.ne.tbest4).or.
     &   (tbest1.eq.0.or.tbest2.eq.0.or.tbest3.eq.0.or.tbest4.eq.0.))
     &    then
       
 	 dmin=1e5 
 	 if(gr.gt.3.2)then
 	   do i=1,6
 	    do j=1,32
 	      dist_mod=sqrt((marcs_tmp(j,i)-t)**2+
     &	       (marcs_tmp(33,i)-gr)**2)
 	      dmin=min(dist_mod,dmin) 
 	      
 	      if(dist_mod.eq.dmin)then
 		t_best0=marcs_tmp(j,i)
 		g_best0=marcs_tmp(33,i)
 	      endif
 	      
 	    enddo
 	   enddo   
 	 endif 
 	  
 	 dmin=1e5 
 	 if(gr.le.3.2)then
 	   do i=1,9
 	    do j=1,32
	     if(marcs_tmp(j,i).ne.0.)then
 	      dist_mod=sqrt((marcs_tmp(j,i)-t)**2+
     &	       (marcs_tmp(33,i)-gr)**2)
 	      dmin=min(dist_mod,dmin) 
 	      
 	      
 	      if(dist_mod.eq.dmin)then
 		t_best0=marcs_tmp(j,i)
 		g_best0=marcs_tmp(33,i)
 	      endif
 	     endif 
 	    enddo
 	   enddo
 	 endif 
 	 t=int(t_best0)
 	 gr=g_best0
 	 
	 
	 teff_n1=t
	 teff_n2=t
	 logg_n1=gr
	 logg_n2=gr
	 
         write(*,*)'CLOSEST MARCS MODEL: OPTIMIZATION SWICHTED OFF'
	 modxxx=1 
	 epot=0
	 
	 if(pday.eq.2)epot=0
	 if(pday.eq.4)grc=0
	 
      endif	 
     
     
C-----------------------------------------------------------------     
     
     
      met0=fe*100.
      
      if(met0.gt.-100.and.met0.lt.0)
     &  write(metalc,'(A2,I2)')'m0',int(abs(met0))
      if(met0.le.-100)write(metalc,'(A1,I3)')'m',int(abs(met0))
      if(met0.lt.100.and.met0.gt.0)write(metalc,'(A2,I2)')'p0',int(met0)
      if(met0.ge.100)write(metalc,'(A1,I3)')'p',int(met0)      
      if(met0.eq.0)write(metalc,'(A4)')'p000'   

     
C-----------------------------------------------------------------     
       
      if(geometry.eq.0)then
        !---------SPHERICAL GEOMETRY
	gridm=marcs(1:len_trim(marcs))//'/marcs_'//
     &        metalc(1:len_trim(metalc))//'k2.sp'
      endif
      
      if(geometry.eq.1)then
        !---------PLANE-PARALLEL GEOMETRY
	gridm=marcs(1:len_trim(marcs))//'/marcs_'//
     &        metalc(1:len_trim(metalc))//'k1.pp'
      endif
     
     
C--------------------------------------------------------     

      open(29,file=gridm,status='unknown')
      i=0
100   read(29,*,end=101)      
      i=i+1
      goto 100
101   continue
      nline=i
            
      rewind(29)      
      
      open(30,file='marcs_model1',status='unknown') 
      open(31,file='marcs_model2',status='unknown') 
      open(32,file='marcs_model3',status='unknown') 
      open(33,file='marcs_model4',status='unknown') 
         
      !--------------------------------	
       do ik=1,4	
       
       	if(ik.eq.1)then
	  munit=30
	  par1=teff_n1
	  par2=logg_n1
	endif
       	if(ik.eq.2)then
	  munit=31
	  par1=teff_n1
	  par2=logg_n2
	endif
       	if(ik.eq.3)then
	  munit=32
	  par1=teff_n2
	  par2=logg_n1
	endif
       	if(ik.eq.4)then
	  munit=33
	  par1=teff_n2
	  par2=logg_n2
	endif
	
	
	read(29,*)
	do i=2,(nline-309),310
	 read(29,*)marcst
	 read(29,*)
	 read(29,*)marcsg
	 marcsg=log10(marcsg)
	  if(marcst.eq.par1.and.abs(marcsg-par2).lt.1e-2)marcsline=(i-1)
	  do j=(i+3),(i+309)
	   read(29,*)cara
	  enddo	  
	enddo
	rewind(29)
	
	open(munit)
	
	do i=1,(marcsline-1)
          read(29,*)
        enddo
	   
	do i=marcsline,(marcsline+309)
	  read(29,'(A110)')cara
	  write(munit,'(A110)')cara
	enddo  
	close(munit)
	rewind(29)
       
       
        if(t.eq.par1.and.gr.eq.par2)then
          write(munit_c,'(A11,I1)')'marcs_model',ik
	  call system('cat '//munit_c//' | marcstoatlas')
          call system('mv fort.88 atmmod.gala')
     	  goto 603
        endif
       
       
       
      enddo
     
      close(29)

	           
      
      open(31,file='marcs_gala.sh',status='unknown')
      
      write(31,'(A27)')'interpol_marcstoatlas <<EOF'
      write(31,'(A12)')'marcs_model1'
      write(31,'(A12)')'marcs_model1'
      write(31,'(A12)')'marcs_model2'
      write(31,'(A12)')'marcs_model2'
      write(31,'(A12)')'marcs_model3'
      write(31,'(A12)')'marcs_model3'
      write(31,'(A12)')'marcs_model4'
      write(31,'(A12)')'marcs_model4'
      write(31,'(I5)')t
      write(31,'(F6.2)')grxxx
      write(31,'(F6.2)')fe
      write(31,'(A7)')'.false.'
      write(31,'(A7)')'.false.'
      write(31,'(A3)')'EOF'
      close(31)
      
      call system('chmod a+x marcs_gala.sh')
      call system('./marcs_gala.sh')
      
      call system('mv fort.88 atmmod.gala')
      
C-----------------------------------------------------------------     

      



C---------------------------------------------------------------- WIDTH with EW  

603   continue
      call xwidth9(star,vt)
     
      status=access('fort.10',' ')
      if(status.ne.0)goto 500
      	
	
      open(unit=10,status='unknown')     
      ie=1
31    read(10,*,end=310)wl(ie),ew(ie),gf(ie),ep(ie),vec0(ie),
     &      vec_err(ie),cod(ie),ewtheo(ie)
                 
      if(nn.eq.1)then
        matrix(ie,1)=wl(ie)
        matrix(ie,2)=ew(ie)
        matrix(ie,3)=gf(ie)
        matrix(ie,4)=ep(ie)
        matrix(ie,5)=cod(ie)
	matrix(ie,12)=0
      endif
      matrix(ie,6)=vec0(ie)    
      matrix(ie,21)=ewtheo(ie)     
      if(x_err.eq.1)matrix(ie,13)=vec0(ie)
      if(x_err.eq.2)matrix(ie,14)=vec0(ie)
      
      
      if(x_uncer.eq.1)matrix(ie,15)=vec0(ie)
      if(x_uncer.eq.2)matrix(ie,16)=vec0(ie)
      
      if(x_uncer.eq.3)matrix(ie,17)=vec0(ie)
      if(x_uncer.eq.4)matrix(ie,18)=vec0(ie)
      
      if(x_uncer.eq.5)matrix(ie,19)=vec0(ie)
      if(x_uncer.eq.6)matrix(ie,20)=vec0(ie)
      
      
      ie=ie+1
      goto 31
310   continue 
      close(10)  
      
      !--------ie=num_lin
      ie=ie-1
      

C--------------------------------------------------------- uncertanties in A(Fe)  

      do ij=1,ie
         if(matrix(ij,6).eq.99.990)matrix(ij,7)=99.990
	 if(matrix(ij,6).ne.99.990)then	   
	   if(xer0.ne.0)matrix(ij,7)=vec_err(ij) 
	   if(xer0.eq.0)matrix(ij,7)=0.0
	 endif  
	 if(matrix(ij,7).lt.0.01.and.xer0.ne.0)matrix(ij,7)=0.01
      enddo	 
      
 
      
C--------------------------------------------------------- uncertanties in EW
C     
      
      if(nn.eq.1)then
      
       open(unit=3,file=inp,status='unknown')   
       ie=1 
787    read(3,*,end=789)x,x,xer(ie)
        matrix(ie,8)=xer(ie)
        matrix(ie,9)=xer(ie)/ew(ie)*100  
        matrix(ie,10)=log10(matrix(ie,2)/matrix(ie,1))-3  
      
      
        if(matrix(ie,9).ge.error)matrix(ie,11)=-2
        if(matrix(ie,10).ge.ewmin.and.matrix(ie,10).le.ewmax.and.
     &     matrix(ie,11).ne.-2)matrix(ie,11)=1
        if(matrix(ie,10).lt.ewmin.or.matrix(ie,10).gt.ewmax.and.
     &     matrix(ie,11).ne.-2)matrix(ie,11)=-1
	if(matrix(ie,6).eq.99.990)matrix(ie,11)=-3
	
	if(matrix(ie,7).gt.1.)matrix(ie,11)=-3
	
	
       
       ie=ie+1
       goto 787
789    continue
       close(3)  
       
       num_lin=ie-1
      
       nfe1=0
       nfe2=0
        do ij=1,num_lin
         if(matrix(ij,11).eq.1.and.matrix(ij,5).eq.qiron)nfe1=nfe1+1
	 if(matrix(ij,11).eq.1.and.matrix(ij,5).eq.qiron2)nfe2=nfe2+1
	enddo
      endif
      
      
      do ij=1,num_lin
       if(matrix(ij,6).eq.99.990)matrix(ij,11)=-3      
      enddo      

!-------------------------------------------- patch per il problema dei NaN .... e' una cosa temporanea !!!!!!
      i=1
      do ij=1,num_lin
        if(matrix(ij,5).eq.qiron.and.matrix(ij,11).eq.1.and.
     &     matrix(ij,6).lt.99.990)then
          verguenza(i)=matrix(ij,6)
	  
	  i=i+1
        endif
      enddo
	 i=i-1
      
      call calsig(verguenza,i,verguenza_m,verguenza_s)
      
      do ij=1,num_lin
        if(matrix(ij,5).eq.qiron.and.matrix(ij,11).eq.1.and.
     &     matrix(ij,6).ge.99.990)matrix(ij,6)=verguenza_m
      enddo
     
            
      
500   continue  
      
      return
      end subroutine
