CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      subroutine runw(star,temp,gr,met,vmic,alfa,nn)


      implicit none
      include 'Declare.f' 
      include 'Paths.f'          
      
     	    
      inp=star(1:len_trim(star))//'.in'
      
      !----at the first run
      
      if(nn.eq.1)then
        open(unit=3,file=inp,status='unknown')  
783     read(3,'(A)',end=784)linec
        linei=index(linec,'*')
	if(linei.ne.0)then
         write(*,*)'EXIT FOR ***** IN WIDTH INPUT FILES'
	 iexit=5
	 goto 500	
	endif
	goto 783
784     continue
        close(3)	
      endif
      
      
      
      !----at the first run read the EW errors from the input file *****.in
      
      if(nn.eq.1)then
       xer0=0
       open(unit=3,file=inp,status='unknown')   
       ie=1 
785    read(3,*,end=786)x,x,xer(ie)
       xer0=xer0+xer(ie)
       ie=ie+1
       goto 785
786    continue       
       close(3)
      endif
      
      ! alternative model
      if(ym.eq.0)goto 603
      
      
      
      
C----------------------------------------------------------------- 
      
      call Atlas9(star,temp,gr,met,vmic,alfa)
      
      if(iexit.eq.3)then
        call alter(star,11)
        return
      endif
      
      if(iexit.eq.4)then
        call alter(star,11)
        return
      endif

      
      status = access(outmod,' ')
      
      if(status.ne.0)goto 601
      if(status.eq.0)goto 603


      
      
C------------------------------------------------------ read the guess ATLAS9 model
601   continue

      open(29,file=gridm,status='unknown')
      
      ! dimension of the grid (kurline0)      
      kurline0=0
800   read(29,*,end=801)
      kurline0=kurline0+1
      goto 800
801   continue

      rewind(29)        
      
      
      ! teff and logg of the grid      
      k=1 
      k0=-96
      do i=1,kurline0,97
        read(29,*)cara,kurt,cara,kurg
	do j=(i+1),(i+96)
	 read(29,*)
	enddo 
	kurt0(k)=kurt 
	kurg0(k)=kurg 
	kurl0(k)=k0+97
	k0=kurl0(k)
	k=k+1 
      enddo
      
      
      ! distance from the atmospheric parameters      
      do i=1,k-1
        dis_tg(i)=sqrt((temp-kurt0(i))**2+(gr-kurg0(i))**2)
      enddo
      
      call sort4(k-1,dis_tg,kurt0,kurg0,kurl0)      
      
      rewind(29)
      
      
      ! write the guess model         
      open(28,file='inmodel.at9',status='unknown')
      
      do i=1,int(kurl0(1)-1)
       read(29,*)
      enddo
  
      do i=int(kurl0(1)),int(kurl0(1)+96)
        read(29,'(A110)')cara
	write(28,'(A110)')cara
      enddo
      
      close(28)
      close(29)


C------------------------------------------------------

      call system('rm fort.*')
      
      call system('ln -s '//at9_dir(1:len_trim(at9_dir)) 
     &//'/ODF/'//kapros(1:len_trim(kapros))//' fort.1')
     
      call system('ln -s '//at9_dir(1:len_trim(at9_dir)) 
     &//'/ODF/'//odf(1:len_trim(odf))//' fort.9')
     
      call system('ln -s '//exe(1:len_trim(exe)) 
     &//'molecules.dat fort.2')
      
      call system('ln -s inmodel.at9 fort.3')
   
    
C------------------------------------------------------ write the script to launch ATLAS9
      
      
      open(31,file='atlas9_gala.sh',status='unknown')
      write(31,'(A200)')at9exe(1:len_trim(at9exe))//
     &'atlas9mem.exe << EOF > '//outlog  
      
      write(31,'(A10)')'READ KAPPA'
      write(31,'(A10)')'READ PUNCH'
      write(31,'(A12)')'MOLECULES ON'
      write(31,'(A14)')'READ MOLECULES'
      write(31,'(A25)')'FREQUENCIES 337 1 337 BIG'
      write(31,'(A6,I1,A4)')'VTURB ',nint(vmic),'.0E5'
      write(31,'(A25)')'CONVECTION OVER 1.25 0 36'
      write(31,'(A18)')'TITLE ATLAS9 MODEL'
      
      do i=1,kuriter
      write(31,'(A22,I5,F5.2)')'SCALE 72 -6.875 0.125  ',temp,gr
      write(31,'(A50)')
     &'ITERATIONS 15  PRINT 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1'
      write(31,'(A35)')'PUNCH 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1'
      write(31,'(A29)')'BEGIN ITERATION  15 COMPLETED'
      enddo
     
      write(31,'(A3)')'END'
      write(31,'(A3)')'EOF'
      
      close(31)
      
      
        
C------------------------------------------------------ ATLAS9
      
      if(verbose.ge.2)write(*,*)'CALL ATLAS9'
      call system('chmod a+x atlas9_gala.sh')
      call system('./atlas9_gala.sh')
      call system('mv fort.7 '//outmod)
      call system('cp atlas9_gala.sh test.script')
      status = access(outmod ,' ') 
      
      if(status.eq.0)then
        if(verbose.ge.2)
     &   write(*,*)'            ------->    CALCULATED THE MODEL ',
     &   outmod(index(at9_dir," ")+12:len_trim(outmod))
      else
        iexit=2
	goto 500
      endif
    
  
C------------------------------------------------------ check about the convergence of the model

      j=0
      open(32,file=outlog,status='unknown')
700   read(32,*,end=701)
      j=j+1
      goto 700
701   continue      
      
      rewind(32)
      
      do i=1,(j-72)
       read(32,*)
      enddo 
      
      
      
      conv=0
      do i=(j-71),j
        read(32,'(I4,A76,E11.3,A41)')nlay,stlog1,ross,stlog3     
	                
	if(stlog3(23:32).eq.'*********'.or.
     &     stlog3(33:41).eq.'*********')then
           
	   if(verbose.ge.2)
     &         write(*,'(A30,I2,A34,F7.3)')
     &         '             ------->    LAYER ',
     &         nlay,' does not converge log(Tau_Ross)= ',log10(ross)
	   conv=conv+1
	 else
	   backspace(32)
	   read(32,*)nlay,x,x,x,x,x,x,x,ross,x,x,flerr1,flerr2
	   if(abs(flerr2).gt.10.or.abs(flerr1).gt.1)then
	     if(verbose.ge.2)
     &         write(*,'(A30,I2,A34,F7.3)')
     &         '             ------->    LAYER ',
     &         nlay,' does not converge log(Tau_Ross)= ',log10(ross)
	     conv=conv+1
	   endif 
	   
	 endif
      enddo
      
      
      if(conv.eq.0.and.verbose.ge.2)
     &   write(*,*)'            ------->    CONVERGED MODEL'   
            
      close(32)
      
      
      
      
C---------------------------------------------------------------- WIDTH with EW    

603   continue     
      call system('cp '//outmod//' atmmod.gala')
      call xwidth9(star,vmic)
      
      status=access('fort.10',' ')
      if(status.ne.0)goto 500
      	
	
      open(unit=10,status='unknown')    
       
      ie=1
31    read(10,*,end=310)wl(ie),ew(ie),gf(ie),ep(ie),vec0(ie),
     &      vec_err(ie),cod(ie),ewtheo(ie)
       if(nn.eq.1)then
         matrix(ie,1)=wl(ie)
         matrix(ie,2)=ew(ie)
         matrix(ie,3)=gf(ie)
         matrix(ie,4)=ep(ie)
         matrix(ie,5)=cod(ie)
	 matrix(ie,12)=0
       endif
      matrix(ie,6)=vec0(ie)      
      matrix(ie,21)=ewtheo(ie)
      
      
      if(x_err.eq.1)matrix(ie,13)=vec0(ie)
      if(x_err.eq.2)matrix(ie,14)=vec0(ie)
      
      if(x_uncer.eq.1)matrix(ie,15)=vec0(ie)
      if(x_uncer.eq.2)matrix(ie,16)=vec0(ie)
      
      if(x_uncer.eq.3)matrix(ie,17)=vec0(ie)
      if(x_uncer.eq.4)matrix(ie,18)=vec0(ie)
      
      if(x_uncer.eq.5)matrix(ie,19)=vec0(ie)
      if(x_uncer.eq.6)matrix(ie,20)=vec0(ie)
      
      
      ie=ie+1
      goto 31
310   continue 
      close(10)  
      
      
      ie=ie-1
            		

C--------------------------------------------------------- uncertanties in A(Fe)  

      do ij=1,ie
         if(matrix(ij,6).eq.99.990)matrix(ij,7)=99.990
	 if(matrix(ij,6).ne.99.990)then	   
	   if(xer0.ne.0)matrix(ij,7)=vec_err(ij) 
	   if(xer0.eq.0)matrix(ij,7)=0.0
	 endif  
	 if(matrix(ij,7).lt.0.01.and.xer0.ne.0)matrix(ij,7)=0.01
      enddo	 
      
 
      
C--------------------------------------------------------- uncertanties in EW
C     
      
      if(nn.eq.1)then
      
       open(unit=3,file=inp,status='unknown')   
       ie=1 
787    read(3,*,end=789)x,x,xer(ie)
        matrix(ie,8)=xer(ie)
        matrix(ie,9)=xer(ie)/ew(ie)*100   
        matrix(ie,10)=log10(matrix(ie,2)/matrix(ie,1))-3 
        
	
      
        if(matrix(ie,9).ge.error)matrix(ie,11)=-2
        if(matrix(ie,10).ge.ewmin.and.matrix(ie,10).le.ewmax.and.
     &     matrix(ie,11).ne.-2)matrix(ie,11)=1
        if(matrix(ie,10).lt.ewmin.or.matrix(ie,10).gt.ewmax.and.
     &     matrix(ie,11).ne.-2)matrix(ie,11)=-1
	if(matrix(ie,6).eq.99.990)matrix(ie,11)=-3

	
       !!!! end of the 'matrix' definition
       
       ie=ie+1
       goto 787
789    continue
       close(3)  
       
       
      
       nfe1=0
       nfe2=0
        do ij=1,num_lin
         if(matrix(ij,11).eq.1.and.matrix(ij,5).eq.qiron)nfe1=nfe1+1
	 if(matrix(ij,11).eq.1.and.matrix(ij,5).eq.qiron2)nfe2=nfe2+1
	enddo
      endif
      
      
      
      do ij=1,num_lin
       if(matrix(ij,6).eq.99.990)matrix(ij,11)=-3      
      enddo

C-------------------------------------------- patch for the occurence of NaN .... 

      i=1
      do ij=1,num_lin
        if(matrix(ij,5).eq.qiron.and.matrix(ij,11).eq.1.and.
     &     matrix(ij,6).lt.99.990)then
          verguenza(i)=matrix(ij,6)	  
	  i=i+1
        endif
      enddo
      i=i-1
      
      call calsig(verguenza,i,verguenza_m,verguenza_s)
      
      do ij=1,num_lin
        if(matrix(ij,5).eq.qiron.and.matrix(ij,11).eq.1.and.
     &     matrix(ij,6).ge.99.990)matrix(ij,6)=verguenza_m
      enddo
     

      
500   continue      

      return
      end subroutine



