CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


C------------------------------------------- Spearman rank-order correlation coefficient

      subroutine spear0(x,y,n,rank)
      
      implicit none
      
      integer i,n
      real*4 x(n),y(n),z(n),v(n),r1(n),r2(n)
      real*4 numa,numb,numc,rank
      
      do i=1,n
        z(i)=x(i)
	v(i)=i
	r1(i)=i
      enddo
      
      call sort2(n,z,v)
      call sort2(n,v,r1)
      
      do i=1,n
        z(i)=y(i)
	v(i)=i
	r2(i)=i
      enddo
      
      call sort2(n,z,v)
      call sort2(n,v,r2)
      
      do i=1,n
        r1(i)=r1(i)-(n+1)/2
        r2(i)=r2(i)-(n+1)/2
      enddo
      
      numa=0.
      numb=0.
      numc=0.
      do i=1,n
        numa=numa+(r1(i)*r2(i))
	numb=numb+(r1(i)**2)
	numc=numc+(r2(i)**2)
      enddo
      
      rank=numa/sqrt(numb*numc)
      
      end subroutine
      
      
