CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of GALA					               C
C                                                                              C
C     GALA is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     GALA is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with GALA. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine uncert(star,t,g,m,v,alfa)

          
      implicit none
      include 'Declare.f'           
      
      if(verbose.ge.2)
     &write(*,*)'-----------------------------------------------
     &----UNCERTAINTIES CALCULATION'
      
      mean0=mean
      mean0_2=mean2
   
C----------------------------------------------------------- uncertainty of Teff      
C
C     it is computed only if Teff is optimized spectroscopically (epot=1)   

      if(epot.eq.1)then
              
      if(jack_teff.eq.0)then
       if(uncer_t.eq.0)uncer_t=stepteff
       goto 401
      endif
      
       do i=-100,100,200
     	t_new=t+i
	 if(t_new.lt.3500)then
	   t_new=3500
	   t=t+100
	 endif

     	call xabu(star,t_new,g,m,v,alfa,2)
     	if(i.eq.-100)then
	  par_t0=par_t
	  tnumber1=t_new
	endif  
	if(i.eq.100)then
	   t=param_0(1)
	   tnumber2=t_new
	 endif  

       enddo
        
	if(tnumber1.ne.tnumber2)then
          c_at=(par_t-par_t0)/(abs(tnumber1-tnumber2))
	  uncer_t=(abs(jack_teff/c_at))**2     
	  uncer_t=sqrt(uncer_t)
          t_null=tnumber2-par_t/c_at
	else
	  uncer_t=0.
	endif  
	
401   continue
	
      else      
      	
	if(uncer_t.le.0.)uncer_t=stepteff
	
      endif
      
      
      
      !-----approximation of sigma(Teff)
      uncer_t0=uncer_t      
      if((uncer_t/10.-int(uncer_t/10.)).le.0.5)then
         uncer_t=10.*int(uncer_t/10.)
      else	 
         uncer_t=10.*int((uncer_t+10.)/10.)
      endif
      
      
C----------------------------------------------------------- uncertainty of vt     
C
C     it is computed only if vt is optimized spectroscopically (vtc=1)  
 
      if(vtc.eq.1)then   
       
       
      if(jack_vt.eq.0)then
       if(uncer_vt.eq.0)uncer_vt=stepvt
       goto 503
      endif
      
       
       x=-0.2
500    v_new=v+x

       if(v_new.lt.0)then
        v_new=0.0
        v=v_new+0.2
       endif 
       call xabu(star,t,g,m,v_new,alfa,2)
       if(x.eq.-0.2)then
         par_v0=par_v
         vnumber1=v_new
	 x=0.2
	 goto 500
       endif  
       if(x.eq.0.2)then
          v=param_0(4)
          vnumber2=v_new
       endif  
	
       
        c_avt=(par_v-par_v0)/(abs(vnumber1-vnumber2))       
	uncer_vt=(abs(jack_vt/c_avt))**2     
	uncer_vt=sqrt(uncer_vt)    
        vt_null=vnumber2-par_v/c_avt

503   continue       
       
      else      
      
	if(uncer_vt.le.0.)uncer_vt=stepvt
	      	    
      endif
      
     
C----------------------------------------------------------- uncertainty of logg   

      if(grc.eq.1)then
      
      !write(*,*)jack_logg,uncer_g
      
      if(jack_logg.eq.0)then
       if(uncer_g.eq.0)uncer_g=stepgr
       goto 502
      endif
      
       
       x=-0.2
501    g_new=g+x
       if(g_new.lt.0)then
         g_new=0.
	 g=g+0.2
       endif 
       call xabu(star,t,g_new,m,v,alfa,2)
       difg=(mean-mean2)

       if(x.eq.-0.2)then
         difg0=difg
         gnumber1=g_new
	 x=0.2
	 goto 501
       endif  
       if(x.eq.0.2)then
         g=param_0(2)
         gnumber2=g_new
       endif
       
       
       if(gnumber1.ne.gnumber2)then

         c_ag=(difg-difg0)/(abs(gnumber1-gnumber2))!!!!!!!!!!!!
         uncer_g=abs(jack_logg/c_ag)	    
         g_null=gnumber2-difg/c_ag
       else
         uncer_g=0
       endif  
	
502    continue   
       	
      else      
       
       if(uncer_g.le.0.)uncer_g=stepgr
       
        
      endif
   
       
C--------------------------------------------------------------------- 	    
C  Uncertainties in the abundances due to the atmospherical parameters 
C  following the method by Cayrel et al.(2004)	    
C
     
     
      if(uncer.ne.0)then
     
    
       if(epot.eq.1)then
       
       if(verbose.ge.2)
     &     write(*,*)'Abundance uncertainties following 
     & Cayrel et al.(2004)'
996    continue
       count0=0
       count2=count2+1
      
       epot=0
       t_new=param_0(1)+uncer_t
       x_err=x_err+1
       
       call xabu(star,t_new,g,m,v,alfa,2)
       
       store_slope(1)=caew
       par_v0=caew
       count0 = 1
       call loopvt(v,t_new,m,g,star,alfa,par_v0,count0,num,mean)  
      
     
        if(x_err.eq.1)then
         t=param_p(1)
         g=param_p(2)
         m=param_p(3)
         v=param_p(4)
         alfa=param_p(5)
 
        endif
      
     
        if(x_err.eq.2)then
         t=param_m(1)
         g=param_m(2)
         m=param_m(3)
         v=param_m(4)
         alfa=param_m(5)
 
        endif
      
C------- 
   
       
       call xabu(star,t,g,m,v,alfa,2)
       
       if(x_err.eq.1)then
           mean_p=mean
           mean2_p=mean2
       elseif(x_err.eq.2)then
           mean_m=mean
           mean2_m=mean2
       endif   	 
         
       uncer_t=-uncer_t      
       
       if(x_err.lt.2)then
        g=param_0(2)
	m=param_0(3)
	v=param_0(4)
	goto 996   
       endif
       x_err=3
       
       else
       
        mean_p=mean0
	mean_m=mean0
	mean2_p=mean0_2
	mean2_m=mean0_2
	
       endif 
      
      
      endif
      
   
C--------------------------------------------------------------------- 	    
C  Uncertainties in the abundances due to the atmospheric parameters 
C  following the classical method without covariance terms    
C
      x_uncer=0
      if(uncer.eq.2)then
      
      if(verbose.ge.2) 
     &write(*,*)'--------------------------------------------
     &CLASSICAL UNCERTAINTIES CALCULATION',x_err
       epot=0
       grc=0
       vtc=0
       
       t=param_0(1)
       g=param_0(2)
       m=param_0(3)
       v=param_0(4)
       alfa=param_0(5)
       
      !------------------------------------------------------- +- teff 
       x_uncer=1
       t_class=(t+uncer_t)
       if(verbose.ge.2)
     &   write(*,*)'---- analysis with Teff + sigma(Teff)'
       call xabu(star,t_class,g,m,v,alfa,2)
         mean_tp=mean
	 mean_tp2=mean2      
	 
       x_uncer=2
       t_class=(t-uncer_t)
       if(ym.eq.2.and.t_class.lt.3500)t_class=3500
       if(verbose.ge.2)
     &   write(*,*)'---- analysis with Teff - sigma(Teff)'
       call xabu(star,t_class,g,m,v,alfa,2)
         mean_tm=mean
	 mean_tm2=mean2
       
      !------------------------------------------------------- +- logg        
       x_uncer=3
       g_class=(g+uncer_g)
       if(verbose.ge.2)
     &   write(*,*)'---- analysis with logg + sigma(logg)'
       call xabu(star,t,g_class,m,v,alfa,2)
         mean_gp=mean
	 mean_gp2=mean2
       
       x_uncer=4
       g_class=(g-uncer_g)
       if(g_class.lt.0)g_class=0.
       if(verbose.ge.2)
     &    write(*,*)'---- analysis with logg - sigma(logg)'       
       call xabu(star,t,g_class,m,v,alfa,2)
         mean_gm=mean
	 mean_gm2=mean2
       
      !------------------------------------------------------- +- vt 
       x_uncer=5
       v_class=(v+uncer_vt)
       if(verbose.ge.2)
     &   write(*,*)'---- analysis with vturb + sigma(vturb)'
       call xabu(star,t,g,m,v_class,alfa,2)  
         mean_vp=mean
	 mean_vp2=mean2
       
       x_uncer=6
       v_class=(v-uncer_vt)
       if(v_class.lt.0)v_class=0.
       if(verbose.ge.2)
     &    write(*,*)'---- analysis with vturb - sigma(vturb)'       
       call xabu(star,t,g,m,v_class,alfa,2)
         mean_vm=mean
	 mean_vm2=mean2
       
       
       !-------------------------------------------------------
       x_uncer=0
       x_err=3
       
      
      endif
      
      
      return
      end subroutine
